package 
{
	import com.greensock.*;
	import flash.display.*; 
	import flash.events.*;
	import flash.media.Sound;
	import flash.net.*;
	import flash.geom.*;
	import flash.text.*;
	import com.greensock.easing.*;

	
	/**
	 * @author Niels Erik Kaaber Rasmussen
	 */
	public class Bubble extends MovieClip {
		private var subColors:Array,subSceneOpen:Boolean, subBubblePosX:Array, subBubblePosY:Array,acts:Array, directives:Array, regulations:Array, decisions:Array, subDirectives:Array, subRegulations:Array, subDecisions:Array, positionX:int, positionY:int, color:int, bubbleName:String, bubbleGraphic:BubbleGraphic, bubbleText:TextField, bubbleInfo:String, myFormat:TextFormat, myFormatb:TextFormat, circleSound:Sound, sceneSound:Sound, circleRadius:Array, timeunit:Number, circleSubRadius:Array, subScene:SubScene, primary:Boolean, subBubbleTitles:Array;
//		private var tmptext2:TextField = new TextField(); //debug txt
		
		public function Bubble(posX:int, posY:int, radius:Array, nameOfBubble:String, acts:Array, directives:Array, regulations:Array, decisions:Array, subRadius:Array, timeunit:Number, bgclr:int, primaryBubble:Boolean, subBubblesTitles:Array, sDirectives:Array, sRegulations:Array, sDecisions:Array, bubbleColor:Array, subBubblePosX:Array, subBubblePosY:Array, subColors:Array):void {
			this.subColors = subColors;
			this.subBubblePosX = subBubblePosX,
			this.subBubblePosY = subBubblePosY;
			this.subBubbleTitles = subBubblesTitles;
			this.primary = primaryBubble;
			this.timeunit = timeunit;
			this.bubbleName = nameOfBubble;
			this.circleRadius = radius;
			this.positionX = posX;
			this.positionY = posY;
			this.circleSubRadius = subRadius;
			this.subDirectives = sDirectives;
			this.subRegulations = sRegulations;
			this.subDecisions = sDecisions;
			this.acts = acts;
			this.directives = directives;
			this.regulations = regulations;
			this.decisions = decisions;
			subSceneOpen = false;

			circleSound = new Sound();
			circleSound.load(new URLRequest("circlesound.mp3"));
			//circleSound.addEventListener(Event.COMPLETE, soundLoaded);
			this.mouseEnabled = false;

			sceneSound = new Sound();
			sceneSound.load(new URLRequest("opensound.mp3"));
			
			myFormat = new TextFormat("Arial", 10, 0);
			myFormat.align = TextFormatAlign.CENTER;
			myFormat.color = "0x333333";
			myFormat.bold = false;

			myFormatb = new TextFormat("Arial", 10, 0);
			myFormatb.align = TextFormatAlign.CENTER;
			myFormatb.color = "0x000000";
			myFormatb.bold = true;
			
/*			//to be deleted
			addChild(tmptext2); //debug txt
//			tmptext2.text = "Debug text";
			//to be deleted
	*/		
			//draw bubbleGraphic
			bubbleGraphic = new BubbleGraphic(bgclr, primary,bubbleColor);
			addChild(bubbleGraphic);
			bubbleGraphic.x = positionX;
			bubbleGraphic.y = positionY;
			
			bubbleText = new TextField();
			bubbleText.embedFonts = true;
			bubbleText.antiAliasType = AntiAliasType.ADVANCED;
			bubbleText.defaultTextFormat = myFormat;
			bubbleText.text = bubbleName; //set name of circle
			bubbleText.width = 200;
			bubbleText.x = positionX-100;
			bubbleText.y = positionY-7;
			bubbleText.mouseEnabled = false;
			//addChild(bubbleText);
//			setRadius(radius); //initial radius
		} //end bubble function

		public function resizeBubble(year:int):void { //resize bubblegraphic
			if (!contains(bubbleText) && (circleRadius[year] >= 15 || year > 50)) {
				addChild(bubbleText);
			}
			else if (contains(bubbleText) && circleRadius[year] < 15 && year < 50) {
				removeChild(bubbleText);
			}
//			var posX:int = (year / 61 * positionX) + (61 - year) / 61 * 500;
//			var posY:int = (year/61*positionY)+(61-year)/61*250;
			TweenLite.to(bubbleGraphic, timeunit, { /*x:posX,y:posY,*/scaleX:circleRadius[year], scaleY:circleRadius[year], ease:Linear.easeNone } ); //resize circles
		}

		public function getPositionX():int {
			return positionX;
		}

		public function getPositionY():int {
			return positionY;
		}

		public function over(event:MouseEvent):void {
			bubbleText.defaultTextFormat = myFormatb;
			bubbleText.text = bubbleName;
			circleSound.play(100);
			setActInfo();
		}

		public function setActInfo():void {
			if (primary) {
				if (subSceneOpen) {
					bubbleInfo = 'You are now viewing the different categories of legislation within this chapter of European Union legislation. The area of each circle corresponds to the number of legal acts in force (note the change in scale).\n\nBelow you can see how many acts there are of the main legislative types.';
				}
				else {
					bubbleInfo = 'This is one of the 20 top-level classification headings (or chapters) used to categorize European Union legislation. The area of the circle corresponds to the total number of legal acts in force within the classification heading.\n\nBelow you can see how many acts there are of the main legislative types.';
				}
//"Each bubble represents a specific area of European Union activity. The area of the bubble reflects the number of EU legislative acts within the policy area.\n\nUse the timeline to navigate in time. Place the cursor on a bubble to see additional information or click on it to highlight full details.");
				MovieClip(parent).scenary.setInfoBoxText(bubbleName, bubbleInfo);
				MovieClip(parent).scenary.setActInfo(acts,directives,regulations,decisions);
			}
			else { //there might be a better way to do this?
				bubbleInfo = 'The area of this circle corresponds to the total number of legal acts in force within this classification heading.\n\nBelow you can see how many acts there are of the main legislative types.';
				MovieClip(parent.parent.parent).scenary.setInfoBoxText(bubbleName, bubbleInfo);
				MovieClip(parent.parent.parent).scenary.setActInfo(acts,directives,regulations,decisions);
			}		
		}
		public function closeSubScene():void {
			TweenLite.to(subScene, timeunit * 2, { x: positionX, y: positionY, scaleX:0, scaleY:0 } ); //scrink circles
			MovieClip(parent).scenary.resetRuler();
			MovieClip(parent).scenary.resetSceneTitle();
			MovieClip(parent).setSubCircles([]);
			MovieClip(parent).changeYear( MovieClip(parent).thisyear );
			subSceneOpen = false;
			setActInfo();
			sceneSound.play();
//			removeChild(subScene); //oncomplete
		}
			
		public function click(bubbleColor:int):void { //open subscene
//			MovieClip(parent).runAnimation = false; //pause animation
			this.parent.setChildIndex(this, this.parent.numChildren - 1); //move this bubble to top			
			this.parent.setChildIndex(MovieClip(parent).scenary, this.parent.numChildren - 1); //move scenary to top

			subScene = new SubScene(positionX, positionY, bubbleColor, timeunit, circleSubRadius);
			addChild(subScene);
			subScene.initScene(bubbleName, subBubbleTitles, MovieClip(parent).thisyear, subDirectives, subRegulations, subDecisions, subBubblePosX,subBubblePosY,subColors);
			MovieClip(parent).setSubCircles(subScene.subBubble);
			subSceneOpen = true;
			setActInfo();
			sceneSound.play();
		}
		
		public function out():void {
				bubbleText.defaultTextFormat = myFormat;
				bubbleText.text = bubbleName;
			if (!subSceneOpen) {
				MovieClip(parent).setActInfo();
			}
		}
		public function setRadius(initRadius:int):void {
			bubbleGraphic.height = initRadius;
			bubbleGraphic.width = initRadius;
		}
	} //end bubble class
} //end package