package 
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.display.*; 
	import flash.events.*;
	import flash.geom.*;
	import flash.net.*;
	import flash.text.*;

	/**
	 * @author Niels Erik Kaaber Rasmussen
	 */
	public class BubbleGraphic extends MovieClip {
		private var bubble:Sprite, bubbleColorLight:int;
		public function BubbleGraphic(bgclr:int, primaryBubble:Boolean,bubbleColors:Array):void {
			const circRad:int = 1; //initial circle radius
			
			this.mouseEnabled = false;
						
			var shadowMatr:Matrix = new Matrix();
			shadowMatr.createGradientBox(2 * circRad, 2 * circRad, 0, -circRad, -circRad);

			var shadow:Sprite = new Sprite();
			shadow.graphics.drawCircle(0, 0, 1);
			shadow.graphics.endFill();
			shadow.graphics.beginGradientFill(GradientType.RADIAL, [0x000000,bgclr], [0.5,0], [200,255], shadowMatr, SpreadMethod.PAD);
			shadow.graphics.drawCircle(0, 0, 1);
			shadow.x = -0.15;
			shadow.y = 0.15;
			shadow.mouseEnabled = false;
			addChild(shadow);
			setChildIndex(shadow, 0); //object<>MC issue here?

			bubble = new Sprite();
			
			var red:int = int(Math.random() * (1 + 255 - 20) + 20);
			var green:int = int(Math.random() * (1 + 255 - 20) + 20);
			var blue:int = int(Math.random() * (1 + 255 - 20) + 20);
 			var bubbleColor:int = int("0x" + red.toString(16) + green.toString(16) + blue.toString(16));
			red = Math.min(255, red + 50);
			green = Math.min(255, green + 50);
			blue = Math.min(255, blue + 50);
  			bubbleColorLight = int("0x" + red.toString(16) + green.toString(16) + blue.toString(16));
			bubbleColor = bubbleColors[0];
			bubbleColorLight = bubbleColors[1];
		
			var matr:Matrix = new Matrix();
			matr.createGradientBox(2 * circRad, 2 * circRad, 0, -circRad + 0.3, -circRad - 0.3);

//			var bubbleColor:int = Math.random() * 0xFFFFFF;
			bubble.graphics.beginGradientFill(GradientType.RADIAL, [0xDDDDDD,bubbleColor], [1,1], [0,255], matr, SpreadMethod.PAD);
			bubble.graphics.drawCircle(0, 0, 1);
			addChild(bubble);

			if (primaryBubble) {
				bubble.addEventListener(MouseEvent.CLICK, click);
				bubble.buttonMode = true;
			}
			bubble.addEventListener(MouseEvent.ROLL_OVER, over);
			bubble.addEventListener(MouseEvent.ROLL_OUT, out);

			function over (event:MouseEvent):void {
				MovieClip(parent).over(event);
				bubble.transform.colorTransform = new ColorTransform(1.2, 1.2, 1.2, 1, 0, 0, 0, 1);
			} //end over

			function out (event:MouseEvent):void {
				MovieClip(parent).out();
				bubble.transform.colorTransform = new ColorTransform(1,1,1,1,0,0,0,1);
			} //end out
		
			function click (event:MouseEvent):void {
				MovieClip(parent).click(bubbleColorLight);
			} //end click
			
		} //end bubbleGraphic function
	} //end bubbleGraphic class
} //end package