﻿package 
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;

	/**
	 * ...
	 * @author Niels Erik Kaaber Rasmussen
	 * Thanks to FlashDeveloper for the template for this class
	 */
	public class Preloader extends MovieClip {
		private var preloader:Shape;
		private var progressText:TextField;
		private var infoText:TextField;
		//private var loaderG:Sprite;
		
		public function Preloader() 
		{
			trace('Hello world, says the preloader');
			addEventListener(Event.ENTER_FRAME, checkFrame);
			loaderInfo.addEventListener(ProgressEvent.PROGRESS, progress);
			// show loader
			
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;

			preloader = new Shape();
			preloader.graphics.beginFill(0xAAAAAA);
			preloader.graphics.drawRect( -13, -15, 30, 30);
			preloader.graphics.endFill();
			preloader.x = 500;
			preloader.y = 200;
			addChild(preloader);
			
			progressText = new TextField();
			var progressTextFormat:TextFormat = new TextFormat("_sans", 20, 0xAAAAAA, true);
			progressTextFormat.align = TextFormatAlign.CENTER;
			progressText.defaultTextFormat = progressTextFormat;
			progressText.x = 350;
			progressText.y = 230;
			progressText.width = 300;
			addChild(progressText);
			
			infoText = new TextField();
			infoText.width = 300;
			infoText.defaultTextFormat = progressTextFormat;
			infoText.text = "Loading data...";
			infoText.x = 350;
			infoText.y = 140;
			addChild(infoText);
		}
		
		private function progress(e:ProgressEvent):void 
		{
			// update loader
			if (progressText) {
				progressText.text = Math.round(e.bytesLoaded/e.bytesTotal*100).toString() + " %";
			}
		}
		
		private function checkFrame(e:Event):void 
		{
			preloader.rotation += 5;
			if (currentFrame == totalFrames) 
			{
				removeEventListener(Event.ENTER_FRAME, checkFrame);
				startup();
			}
		}
		
		private function startup():void {
			// hide loader
			stop();
			removeChild(preloader);
			removeChild(progressText);
			removeChild(infoText);
			preloader = null;
			progressText = null;
			infoText = null;
			loaderInfo.removeEventListener(ProgressEvent.PROGRESS, progress);
			var mainClass:Class = getDefinitionByName("Main") as Class;
			addChild(new mainClass() as DisplayObject);
		}
	}
}