package 
{
	import com.greensock.*;
	import com.greensock.plugins.HexColorsPlugin;
	import flash.display.*; 
	import flash.events.*;
	//import flash.media.Sound;
	import flash.net.*;
	import flash.geom.*;
	import flash.text.*;
  import flash.events.KeyboardEvent;
  import flash.ui.Keyboard;
	
	/**
	 * @author Niels Erik Kaaber Rasmussen
	 */
	public class SubScene extends MovieClip {
		public var positionX:int, positionY:int, timeunit:Number, bubbleSizes:Array, increaseFactor:Number, max:int, bubbleColor:int;
		public var subBubble:Array;
		public function SubScene(posX:int, posY:int, bgclr:int, tunit:Number, circleSubRadius:Array):void {
			
			positionX = posX;
			positionY = posY;
			timeunit = tunit;
			bubbleSizes = circleSubRadius;
			bubbleColor = bgclr;
			
			var sceneBG:Sprite = new Sprite(); //new bubble to simulate background
			sceneBG.graphics.beginFill(bubbleColor);
			sceneBG.graphics.drawCircle(0, 0, 1);
			sceneBG.x = positionX;
			sceneBG.y = positionY;
			addChild(sceneBG);
			TweenLite.to(sceneBG, timeunit * 2, { scaleX:1000, scaleY:1000 } ); //resize scene background

			addCloseButton();
			increaseFactor = getIncreaseFactor();
			
			function getIncreaseFactor():Number {
				max = 0;
				for (var i:int = 0; i < bubbleSizes.length; i++) {
					if (Math.max.apply(this, bubbleSizes[i]) > max) {
						max = Math.max.apply(this, bubbleSizes[i]);
					}
				}
				return Math.PI * 130 * 130 / max;
			} //end getIncreaseFactor
			
		} //end SubScene function
		
		public function initScene(bubbleName:String, bubbleNames:Array, startYear:int, subDirectives:Array, subRegulations:Array, subDecisions:Array,bubblePosX:Array,bubblePosY:Array,subColors:Array):void {
			MovieClip(parent.parent).scenary.addSceneTitle( bubbleName );
			var tmp:Array = MovieClip(parent.parent).getCirclePositions( bubbleRadius(bubbleSizes) );
			var circleCenterX:Array = tmp[0];
			var circleCenterY:Array = tmp[1];

			subBubble = [];
			for (var i:int = 0; i < bubbleSizes.length; i++) {
				subBubble[i] = new Bubble(bubblePosX[i], bubblePosY[i], actsToRadius(bubbleSizes[i]), bubbleNames[i], bubbleSizes[i], subDirectives[i], subRegulations[i], subDecisions[i], [], timeunit, bubbleColor, false, [], [], [], [],subColors[i],[],[],[]); //create bubble objects
				addChild(subBubble[i]);
				subBubble[i].resizeBubble(startYear);
				//create (sub)bubble
			}
			changeRuler();
//			setActInfo();
		stage.addEventListener(KeyboardEvent.KEY_DOWN, keyPressedDown);
	       function keyPressedDown(event:KeyboardEvent):void {
			   if (event.keyCode == Keyboard.ESCAPE) {
   					stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyPressedDown);
					MovieClip(parent).closeSubScene();
			   }
		  }
		}

		public function bubbleRadius(bubbleSizes:Array):Array {
			var bubbleRadius:Array = [];
			for (var i:int = 0; i < bubbleSizes.length; i++ ) {
				bubbleRadius[i] = actsToRadius(bubbleSizes[i]);
			}
			return bubbleRadius;
		}
		
		public function actsToRadius(bubbleActs:Array):Array {
			var radius:Array = [];
			for (var i:int = 0; i < bubbleActs.length; i++) {
				radius[i] = Math.sqrt(bubbleActs[i] * increaseFactor / Math.PI);
			}
			return radius;
		} //end actsToRadius
		
		public function changeRuler():void { //bubblesize formula: round(sqrt($inforce*$factor/pi()));
			MovieClip(parent.parent).scenary.updateRuler(Math.round(Math.PI * 115 * 115 / increaseFactor), //Given diameter returns number of acts: round(pi()*$r*$r/increaseFactor);
														Math.round(Math.PI * 43.5 * 43.5 / increaseFactor), //Size in ruler: 150-87-62-28 = radius: 75-43.5-31-14
														Math.round(Math.PI * 31 * 31 / increaseFactor),
														Math.round(Math.PI * 14 * 14 / increaseFactor)
														);
		} //end changeRuler

		public function addCloseButton():void {
			const closeLeft:int = 780;
			const closeTop:int = 10;
			const closeWidth:int = 10;
			var buttonClose:Sprite = new Sprite;
			buttonClose.graphics.lineStyle(4, 0x333333);
			buttonClose.graphics.moveTo(closeLeft, closeTop);
			buttonClose.graphics.lineTo(closeLeft+closeWidth, closeTop+closeWidth);
			buttonClose.graphics.moveTo(closeLeft+closeWidth, closeTop);
			buttonClose.graphics.lineTo(closeLeft, closeTop+closeWidth);
			buttonClose.graphics.endFill();
			buttonClose.mouseEnabled = false;
			addChild(buttonClose);

			var buttonCloseC:Sprite = new Sprite();
			buttonCloseC.graphics.beginFill(0xAAAAAA);
			buttonCloseC.alpha = 0;
			buttonCloseC.graphics.drawRect(closeLeft-closeTop/2,closeTop-closeTop/2,closeWidth*2,closeWidth*2);
			buttonCloseC.graphics.endFill();
			buttonCloseC.buttonMode = true;
			addChild(buttonCloseC);
			
			buttonCloseC.addEventListener(MouseEvent.MOUSE_UP, upClose);
			buttonCloseC.addEventListener(MouseEvent.MOUSE_OVER, overClose);
			buttonCloseC.addEventListener(MouseEvent.MOUSE_OUT, outClose);
			buttonCloseC.addEventListener(MouseEvent.MOUSE_DOWN, downClose);
			
			var buttonCloseInner:Sprite = new Sprite;
			buttonCloseInner.graphics.lineStyle(2, 0xAAAAAA);
			buttonCloseInner.graphics.moveTo(closeLeft, closeTop);
			buttonCloseInner.graphics.lineTo(closeLeft+closeWidth, closeTop+closeWidth);
			buttonCloseInner.graphics.moveTo(closeLeft+closeWidth, closeTop);
			buttonCloseInner.graphics.lineTo(closeLeft, closeTop+closeWidth);
			buttonCloseInner.graphics.endFill();
			buttonCloseInner.mouseEnabled = false;
			addChild(buttonCloseInner);

			function overClose(event:MouseEvent):void {
				buttonCloseInner.graphics.lineStyle(2, 0xe05555);
				buttonCloseInner.graphics.moveTo(closeLeft, closeTop);
				buttonCloseInner.graphics.lineTo(closeLeft+closeWidth, closeTop+closeWidth);
				buttonCloseInner.graphics.moveTo(closeLeft+closeWidth, closeTop);
				buttonCloseInner.graphics.lineTo(closeLeft, closeTop + closeWidth);				
			}
			
			function upClose(event:MouseEvent):void {
				MovieClip(parent).closeSubScene();
			}
			
			function outClose(event:MouseEvent):void {
				buttonCloseInner.graphics.lineStyle(2, 0xAAAAAA);
				buttonCloseInner.graphics.moveTo(closeLeft, closeTop);
				buttonCloseInner.graphics.lineTo(closeLeft+closeWidth, closeTop+closeWidth);
				buttonCloseInner.graphics.moveTo(closeLeft+closeWidth, closeTop);
				buttonCloseInner.graphics.lineTo(closeLeft, closeTop+closeWidth);
				buttonCloseInner.graphics.endFill();
			}
			
			function downClose(event:MouseEvent):void {
				buttonCloseInner.graphics.lineStyle(2, 0xFF0000);
				buttonCloseInner.graphics.moveTo(closeLeft, closeTop);
				buttonCloseInner.graphics.lineTo(closeLeft+closeWidth, closeTop+closeWidth);
				buttonCloseInner.graphics.moveTo(closeLeft+closeWidth, closeTop);
				buttonCloseInner.graphics.lineTo(closeLeft, closeTop + closeWidth);
			}
		} //end addCloseButton
		
		public function setActInfo():void {
			MovieClip(parent).setActInfo();
		}
	} //end subscene class
} //end package