﻿package 
{
	import com.greensock.*;
	import flash.display.*;
	import flash.text.*;
	import flash.geom.*;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.URLRequest;

	/**
	 * @author Niels Erik Kaaber Rasmussen and Morten Grunnet Buhl (www.BuhlRasmussen.eu)
	 * This is my first ever AS3 program. I am sure plenty of optimazions can be made.
	 * The project is using data taken from our newly opened API on EU legislation: http://api.epdb.eu
	 * It will be submitted as an entry for the open data contest: opendatachallenge.org
	 * If you find any bugs in the code, let us know (contact@buhlrasmussen.eu).
	 * */

	public class Main extends MovieClip {
		public var clrNr:int, thisyear:int, circles:Array, runAnimation:Boolean, scenary:Scenary, subBubbleTitles:Array, subCircles:Array;
		public static const maxYear:int = 61; //1950+61 = 2011
		public static const numberOfCircles:int = 20;
		
		public var totalNumberOfActs:Array = new Array (0, 0, 0, 13, 21, 26, 38, 44, 64, 86, 99, 123, 200, 249, 321, 363, 412, 491, 656, 838, 1057, 1250, 1468, 1834, 2216, 2577, 2997, 3334, 4021, 4555, 5149, 5942, 6626, 7244, 7643, 7747, 8471, 9012, 9638, 10237, 10823, 11420, 12006, 12141, 12614, 12928, 13777, 14778, 15824, 16404, 17443, 18753, 20006, 21582, 22945, 24664, 25846, 27694, 29428, 30555, 31698, 32088); //total number of acts
		
		public var totalNumberOfDirectives:Array = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 8, 13, 23, 32, 43, 50, 69, 89, 113, 139, 169, 205, 252, 303, 367, 418, 496, 564, 636, 687, 748, 801, 849, 865, 939, 988, 1048, 1132, 1211, 1275, 1345, 1424, 1455, 1478, 1529, 1546, 1594, 1620, 1617, 1640, 1661, 1697, 1773, 1821, 1830, 1886, 1933, 1909, 1936, 1844);
		public var totalNumberOfRegulations:Array = new Array (0, 0, 0, 0, 0, 0, 0, 0, 5, 11, 14, 17, 55, 77, 96, 110, 127, 163, 263, 389, 509, 624, 739, 926, 1061, 1208, 1423, 1578, 1930, 2185, 2497, 2796, 2940, 3170, 3321, 3376, 3774, 4033, 4249, 4440, 4678, 4996, 5228, 5186, 5122, 4889, 4968, 5132, 5445, 5369, 5313, 5329, 5527, 5936, 6287, 6715, 7125, 7700, 8072, 8165, 8377, 8471);
		public var totalNumberOfDecisions:Array = new Array (0, 0, 0, 9, 15, 19, 27, 30, 39, 45, 47, 55, 68, 84, 112, 122, 133, 146, 176, 190, 230, 261, 308, 412, 524, 629, 755, 812, 978, 1163, 1300, 1600, 2007, 2285, 2437, 2516, 2649, 2793, 3045, 3271, 3483, 3654, 3865, 3884, 4347, 4678, 5204, 5877, 6380, 6857, 7762, 8874, 9771, 10729, 11533, 12613, 13263, 14301, 15443, 16362, 17146, 17423);
		
		public function Main():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
	
		private function init(e:Event = null):void {
			runAnimation = true;
			removeEventListener(Event.ADDED_TO_STAGE, init);
			clrNr = 0;

/*			//to be deleted...//
			var tmptext:TextField = new TextField(); //debug txt
			//tmptext.text = 'debug txt (main)';
			addChild(tmptext); //debug txt
			//to be deleted...// */
	
			//entry point
			this.mouseEnabled = false;
//////////////////DATA BEGIN//////////////////
			var circleNames:Array = new Array("General, financial and\nInstitutional matters", "Customs Union and\nfree movement of goods", "Agriculture", "Fisheries", "Freedom of movement\nfor workers and social policy","Right of establishment\nand freedom to provide services", "Transport policy",	"Competition policy","Taxation", "Energy", "External relations","Economic and monetary policy\nand free movement of capital","Industrial policy\nand internal market", "Regional policy and coordination\nof structural instruments","Environment, consumers and\nhealth protection","Science, information,\neducation and culture", "Law relating\nto undertakings", "Common Foreign and\nSecurity Policy","Area of freedom\nsecurity and justice", "People's Europe"); //Navnet på hver cirkel
						
	var circleRadius:Array = new Array(  //Radius for hvert stadie/år af hver cirkel
        new Array(0,0,0,3,4,4,5,5,6,6,7,8,8,9,10,10,11,11,11,12,12,12,13,14,14,15,16,17,18,18,19,20,21,21,22,22,22,23,23,24,24,25,26,27,28,31,33,34,34,36,39,40,38,41,44,47,45,48,51,53,53,54),//dc 1
        new Array(0,0,0,0,0,0,0,0,0,2,2,3,5,5,7,7,7,8,9,11,12,13,14,18,22,23,26,25,29,32,33,38,43,46,47,46,48,45,46,49,51,51,52,50,45,46,47,48,49,50,50,51,52,53,53,53,55,56,56,56,56,56),//dc 2
        new Array(0,0,0,0,0,0,0,0,0,0,0,1,8,9,10,11,12,15,20,24,28,31,35,38,41,45,48,53,58,62,66,69,73,76,78,79,84,87,90,91,93,96,99,98,99,97,98,100,102,101,101,102,103,106,107,110,113,116,118,118,118,119),//dc 3
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,3,3,3,5,5,5,7,7,8,9,10,10,12,12,13,15,16,18,20,22,23,24,26,26,27,27,28,30,29,29,31,31,28,29,29,32,34,37,39,41,44,45,47,47),//dc 4
        new Array(0,0,0,0,0,0,0,1,1,3,4,5,6,7,8,8,9,9,10,10,10,10,8,11,12,13,15,15,16,16,17,17,17,17,18,19,19,20,21,21,22,23,23,24,24,25,25,26,26,26,27,27,28,29,30,30,30,31,31,32,34,35),//dc 5
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,4,5,6,6,7,8,8,8,9,9,10,10,11,11,13,14,14,15,15,15,15,16,16,17,17,18,18,19,19,20,20,21,21,21,22,22,21,21,21,21,21,22,23,23,22,23,24,24,24),//dc 6
        new Array(0,0,0,0,0,1,2,2,3,4,4,5,6,6,6,7,7,8,9,10,10,11,11,12,14,14,15,16,18,19,19,20,21,22,22,23,23,24,24,25,25,26,27,27,28,28,29,29,30,30,31,32,32,33,34,35,36,37,39,40,42,42),//dc 7
        new Array(0,0,0,1,2,2,4,4,5,5,4,4,5,6,7,7,8,8,10,10,11,12,14,15,16,17,18,19,20,21,22,22,24,25,26,27,28,29,30,31,33,35,37,38,41,44,47,50,54,59,64,69,74,78,81,85,88,93,96,99,102,102),//dc 8
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,4,4,4,5,5,6,6,6,7,7,8,8,9,9,10,10,10,11,11,11,12,12,13,13,15,15,15,15,16,17,17,18,19,20,20,21,22,21,21,22,21,22,22),//dc 9
        new Array(0,0,0,0,0,0,0,0,1,1,1,1,2,2,3,3,3,4,4,4,4,5,6,7,8,8,9,9,10,11,11,11,12,12,11,11,11,11,11,11,11,11,11,11,11,12,12,13,15,18,20,22,23,25,27,29,29,31,32,33,36,36),//dc 10
        new Array(0,0,0,1,2,2,2,3,3,5,6,7,8,9,10,10,10,11,12,13,15,17,18,23,27,29,30,29,32,34,38,44,46,48,49,46,47,50,52,54,56,57,58,58,58,62,65,68,72,74,79,84,88,92,95,99,103,105,109,110,113,113),//dc 11
        new Array(0,0,0,2,2,2,4,4,6,6,6,6,7,7,8,8,9,9,9,10,10,10,10,11,12,14,14,15,16,18,18,18,19,19,20,20,20,20,21,21,22,22,23,21,22,22,22,23,23,24,24,25,26,26,26,26,26,27,27,28,29,29),//dc 12
        new Array(0,0,0,3,4,4,5,4,4,5,5,5,6,6,7,7,8,9,9,10,12,13,13,14,16,18,20,22,24,25,27,28,29,30,31,31,32,33,34,36,37,38,39,40,42,42,44,47,47,49,50,51,52,53,55,56,57,58,60,61,64,64),//dc 13
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,2,2,3,3,3,3,4,5,5,5,6,6,8,9,9,10,10,10,10,14,16,21,19,18,12,23,23,24,27,27,24,25,25,30,30,30,31,26,27,28,29,29,29),//dc 14
        new Array(0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,2,3,3,3,3,4,3,4,5,5,8,9,10,11,13,14,15,16,17,18,19,20,22,24,25,26,28,29,31,32,33,34,36,38,39,41,43,44,46,48,50,51,53,54,56,59,60),//dc 15
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,3,3,3,4,4,4,5,6,6,7,8,9,10,10,11,11,11,13,13,14,14,15,18,20,20,21,21,22,22,23,22,23,24,25,25,27,28,28,28,28,29,30,31,31),//dc 16
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,4,4,4,5,5,5,5,5,5,6,6,6,6,7,7,8,9,9,9,10,10,11,11,11,12,12,13,13,14,15,16,17,17,18,19,20,20,20),//dc 17
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,9,11,12,14,16,17,19,19,23,27,30,33,35,38,40,42,42),//dc 18
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,3,3,3,3,3,4,4,5,5,6,6,9,13,15,16,19,23,25,26,28,29,30,31,33,35,37,38,38),//dc 19
        new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7)//dc 20
	);

	var numberOfActs:Array = new Array( 
        new Array(0,0,0,6,8,11,15,17,23,24,31,34,38,47,53,60,65,72,66,77,82,85,99,117,120,127,148,164,176,182,199,233,256,261,273,273,282,299,303,324,342,358,376,406,456,540,619,675,676,742,865,898,833,957,1088,1247,1166,1327,1477,1614,1630,1667),//dc 1
        new Array(0,0,0,0,0,0,0,0,0,2,3,5,12,15,25,25,27,34,43,64,87,100,111,188,265,308,399,367,470,581,612,825,1042,1232,1247,1189,1289,1179,1235,1388,1489,1502,1551,1445,1161,1190,1254,1329,1380,1407,1445,1494,1538,1575,1618,1622,1697,1770,1812,1784,1797,1808),//dc 2
        new Array(0,0,0,0,0,0,0,0,0,0,0,1,34,45,59,70,89,126,225,335,454,562,686,827,958,1145,1328,1578,1902,2174,2478,2743,3049,3259,3448,3538,4006,4369,4620,4765,4971,5296,5551,5494,5651,5366,5514,5704,5940,5833,5819,5905,6112,6394,6523,6916,7264,7697,7966,7993,8003,8034),//dc 3
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,4,4,4,12,14,17,25,29,40,49,59,60,84,88,91,130,153,175,232,265,307,319,375,398,429,427,436,516,486,469,538,535,462,489,496,587,676,770,848,979,1126,1166,1253,1277),//dc 4
        new Array(0,0,0,0,0,0,0,1,1,5,8,12,18,28,34,40,45,49,54,57,61,62,41,63,84,97,122,126,145,150,162,172,164,165,187,201,206,226,241,257,288,299,301,318,330,350,367,376,399,393,410,421,452,491,499,519,516,535,554,581,661,682),//dc 5
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,3,7,15,19,20,25,34,38,41,47,49,56,62,72,73,95,110,112,123,126,134,133,140,153,160,169,175,186,198,207,219,233,241,250,249,265,282,252,247,248,253,261,284,294,298,288,308,323,342,338),//dc 6
        new Array(0,0,0,0,0,1,2,3,6,7,8,15,19,19,22,27,29,33,45,53,59,66,75,89,105,113,131,143,183,199,217,233,259,273,280,304,308,320,328,347,359,378,403,421,436,455,476,485,506,521,550,573,599,635,664,691,750,799,861,933,992,1005),//dc 7
        new Array(0,0,0,1,3,3,7,10,14,14,8,9,16,19,26,30,34,37,53,58,73,84,115,123,139,164,180,198,227,248,275,289,321,355,391,421,432,480,524,566,604,697,790,824,968,1087,1256,1421,1662,1969,2310,2748,3112,3431,3725,4091,4455,4922,5298,5613,5916,5999),//dc 8
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,3,7,8,9,12,14,18,19,20,25,30,34,37,42,44,53,57,61,65,68,73,82,88,93,100,131,125,131,136,155,171,171,182,200,220,222,255,277,249,261,271,261,282,284),//dc 9
        new Array(0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 3, 6, 6, 6, 7, 8, 8, 8, 15, 20, 26, 33, 40, 45, 51, 60, 68, 71, 75, 82, 84, 74, 69, 71, 71, 71, 72, 67, 66, 65, 67, 75, 77, 84, 95, 129, 190, 230, 275, 312, 348, 403, 466, 484, 541, 573, 624, 720, 735),//dc 10
        new Array(0,0,0,1,2,2,2,4,6,17,20,27,41,46,54,58,59,68,84,100,134,157,192,300,419,466,520,485,602,662,810,1115,1220,1329,1381,1223,1286,1405,1560,1696,1766,1877,1927,1940,1917,2191,2400,2630,2936,3167,3534,3998,4412,4869,5202,5630,6003,6329,6729,6973,7266,7333),//dc 11
        new Array(0,0,0,2,3,3,7,11,18,24,20,23,25,28,33,36,42,45,51,53,53,55,62,73,83,105,120,134,149,175,189,194,209,210,227,227,221,227,246,257,270,273,290,255,274,281,288,293,310,322,326,348,372,385,388,390,397,416,427,454,475,468),//dc 12
        new Array(0,0,0,5,8,9,12,10,11,12,15,16,18,20,30,31,37,43,48,60,78,90,100,116,153,181,230,275,322,357,410,455,477,517,542,542,571,606,650,720,775,810,852,906,988,994,1093,1247,1267,1350,1423,1477,1548,1592,1704,1777,1837,1947,2064,2151,2321,2371),//dc 13
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,2,3,4,4,4,4,8,14,14,14,18,24,33,42,43,57,54,59,58,108,142,249,196,177,88,300,307,329,413,428,331,363,368,499,511,524,535,398,416,432,464,476,486),//dc 14
        new Array(0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,4,4,5,5,7,6,7,13,16,35,45,56,74,96,108,122,143,158,187,203,238,271,316,366,401,436,471,564,589,611,661,732,810,884,956,1073,1119,1231,1337,1408,1486,1581,1692,1821,2007,2082),//dc 15
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,3,3,4,4,5,8,8,8,15,19,23,27,38,48,52,55,73,63,68,91,95,108,113,130,185,224,230,242,248,265,272,291,288,306,331,351,368,410,432,461,456,457,484,503,535,543),//dc 16
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,4,7,8,11,12,14,14,14,14,15,18,21,23,23,25,26,33,45,47,49,55,61,68,71,74,81,85,90,97,107,124,138,160,173,183,208,222,235,240),//dc 17
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,25,45,63,85,115,149,160,198,213,311,407,525,609,701,821,904,989,1029),//dc 18
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,4,4,6,6,6,7,9,12,15,21,23,43,91,127,151,198,312,358,392,435,492,528,559,622,692,777,821,838),//dc 19
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,3,3,4,4,5,5,5,5,7,7,7,9,9,13,15,15,15,16,19,19,19,19,22,23,20,22,24,25,26,27)//dc 20
	);		
		
	var numberOfDirectives:Array = new Array( 
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,3,4,4,4,4,5,5,5,5,7,7,6,19,19,20,20,18),//dc 1
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,5,7,9,10,13,14,15,22,24,30,33,32,36,39,45,45,46,48,34,26,24,25,26,21,22,14,14,14,15,15,15,16,18,18,16,17,18,18,19,16,16,16,15),//dc 2
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,4,10,10,11,21,26,33,47,59,76,94,109,121,143,165,195,213,232,242,252,220,248,268,287,305,325,335,364,400,411,435,447,423,422,433,415,426,423,442,456,475,507,550,568,589,619,541),//dc 3
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2),//dc 4
        new Array(0,0,0,0,0,0,0,0,0,1,1,2,4,4,4,4,5,5,6,6,6,6,7,9,10,14,16,19,20,23,27,26,29,30,31,31,34,37,40,46,51,56,63,63,66,68,71,78,86,88,83,82,87,93,93,97,94,88,88,85,89,88),//dc 5
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,4,11,13,14,19,28,30,33,36,38,43,47,51,52,59,65,67,74,76,81,82,84,92,99,103,106,117,125,132,139,136,141,147,143,151,164,130,120,117,120,124,128,135,133,106,118,121,125,119),//dc 6
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,3,3,3,3,4,5,5,6,8,11,14,18,26,26,30,34,36,38,42,43,45,53,52,59,65,70,71,78,87,86,87,104,115,122,134,144,149,156,161,165,171,174,174,172),//dc 7
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,3,3,2,4,2,3,4,4,4,5,6,7,8,8,10,9,9,10,11,11,12,7,7,8,4,4,3,4,4,4),//dc 8
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,3,6,6,7,10,12,15,15,15,19,24,27,30,33,34,41,42,45,47,48,51,55,58,62,67,67,67,65,66,68,70,74,77,79,83,87,95,97,71,75,77,74,80,81),//dc 9
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,3,3,3,3,4,5,5,6,7,2,3,3,4,3,3,3,5,6,7,7,9,10,10,10,10,11,12,12,13,13,13),//dc 10
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,4,3,3,3,3,3,4,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,3,4,4,4,4,5,5,5,5,5,6,6,6),//dc 11
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,3,3,6,7,7,8,9,10,10,11,11,12,13,13,14,13,13,16,16,16,18,20,21,22,21,24,20,21,22,21,25,22,22,23,24,26,30,29,23),//dc 12
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,7,13,14,18,22,36,49,57,68,90,109,145,166,202,225,246,267,295,320,341,354,379,410,444,486,520,553,582,629,646,639,670,684,699,736,768,766,782,764,804,826,837,866,881,833,839,834),//dc 13
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,5,5,6,8,8,8,8,8,8,7,7,8,8,7,8,5,5,5,5),//dc 14
        new Array(0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,2,3,3,3,3,4,4,5,8,10,14,20,24,31,43,48,54,61,69,83,102,111,121,134,146,163,176,186,201,207,205,213,228,240,252,243,254,245,266,277,279,291,301,315,273,267,267),//dc 15
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,4,4,4,7,10,10,10,11,13,13,14,12,13,15,15,16,16,17,19,19,19,20,20,22,22,8,8,9,9,9),//dc 16
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,2,3,5,5,5,5,6,7,9,8,8,9,9,10,16,17,19,21,22,22,23,23,25,26,27,31,31,35,39,41,43,45,46,45,45,47),//dc 17
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1),//dc 18
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,4,6,6,7,7,7,7,7,7,11,12,15,21,21,19,19,21,24,25,26),//dc 19
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,4,4,5,6,6,6,6,7,7,7,7,8,8,5,6,6,6,6,6)//dc 20 
	);
			
	var numberOfRegulations:Array = new Array( 
        new Array(0,0,0,0,0,0,0,0,2,2,2,2,7,11,15,19,22,24,17,22,25,27,33,39,40,43,52,57,63,67,71,75,81,82,83,92,93,105,108,115,119,125,134,138,150,162,167,175,190,196,209,214,210,225,239,263,281,320,336,361,393,402),//dc 1
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,31,49,59,68,94,115,133,166,175,223,261,330,414,440,504,522,500,558,498,548,626,690,695,733,696,482,490,534,578,623,643,676,710,749,777,810,801,865,929,969,934,942,951),//dc 2
        new Array(0,0,0,0,0,0,0,0,0,0,0,1,27,36,46,51,62,95,187,281,370,458,554,668,747,846,985,1141,1395,1591,1742,1878,2014,2117,2212,2279,2630,2885,3002,3064,3189,3433,3598,3525,3641,3322,3343,3449,3621,3476,3331,3228,3337,3477,3529,3735,3889,4174,4256,4142,4071,4092),//dc 3
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,10,14,17,23,27,37,44,53,51,69,56,50,78,92,102,137,154,169,182,211,249,261,268,266,292,293,279,297,307,255,282,281,354,436,508,587,690,807,849,919,947),//dc 4
        new Array(0,0,0,0,0,0,0,0,0,1,2,3,4,10,15,17,17,19,20,20,22,21,8,10,12,13,19,21,27,28,29,35,25,22,24,25,28,31,37,39,39,39,37,42,45,48,49,41,44,48,54,56,64,77,81,93,96,109,121,134,142,154),//dc 5
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,4,6,9,9,10,11,11,13,17,17,18,19,21,26,27,31,35,39,43,49,48),//dc 6
        new Array(0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,3,5,4,10,15,18,21,24,29,30,33,31,28,39,43,43,44,47,50,52,53,52,59,66,72,82,90,91,84,88,94,102,106,115,107,111,112,120,138,154,163,193,221,237,260,296,299),//dc 7
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,5,7,7,8,8,8,9,9,9,9,12,14,14,16,16,16,17,17,17,17,14,16,16,19,20,21,26,29,32,34,37,36,40,42,45,48,49,48,45,49,49,50,53,55,55,58,61,62,58,60),//dc 8
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,2,2,3,8,6,9,11,11,12,14,13,13,14,12,17,22,23,23,26,28,29,28),//dc 9
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,9,10,12,12,12,13,19,20,20,21,19,21,10,10,10,10,11,11,12,11,10,14,14,19,22,33,54,62,74,84,95,105,119,119,130,138,151,163,167),//dc 10
        new Array(0,0,0,0,0,0,0,0,0,3,3,4,5,5,5,6,6,6,7,13,19,29,41,83,110,130,167,171,211,241,316,442,439,473,510,478,434,480,526,549,557,617,596,628,606,650,635,657,717,734,823,851,891,979,1044,1079,1117,1144,1174,1164,1156,1125),//dc 11
        new Array(0,0,0,0,0,0,0,0,3,5,6,6,6,7,7,7,8,8,8,8,8,8,10,13,16,20,23,22,25,33,34,34,36,31,34,30,30,30,30,28,32,26,26,28,27,28,21,22,20,20,21,21,22,25,26,24,23,25,26,43,49,48),//dc 12
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,3,6,10,28,45,25,15,7,3,2,2,5,6,9,7,7,15,25,36,41,47,55,67,72,79,91,105,123,138,157,195,243,317,415,447),//dc 13
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,7,7,7,6,11,12,14,17,19,22,24,24,27,31,35,36,36,42,42,49,52,52,56,58,67,71,75,85,90,99,103,110,118,136,140,145),//dc 14
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,3,5,9,6,11,15,21,32,30,34,40,64,75,84,90,120,144,159,199,228,248,282,333,363,387,421,461,558,711,753),//dc 15
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,3,4,3,4,4,4,3,3,3,3,4,4,4,8,11,14,15,16,19,21,21,22,23,31,42,52,58,65,75,84,97,99),//dc 16
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,4,4,4,4,4,4,4,4,5,7,13,16,18,22,23,24,25,32,40,46,59,65,71,86,103,110,111),//dc 17
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,4,6,9,17,21,33,36,65,97,144,175,210,237,267,308,321),//dc 18
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,5,5,8,8,8,8,9,12,25,35,44,52,61,64,63,70,83,86,87),//dc 19
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,2,2,3)//dc 20
		);

	var numberOfDecisions:Array = new Array( 
        new Array(0,0,0,4,5,8,9,10,13,15,19,21,21,25,26,28,28,30,31,33,36,38,42,55,56,59,69,78,83,83,92,114,126,127,133,123,131,132,128,138,149,156,165,189,217,274,332,360,313,345,412,424,357,458,571,694,587,689,805,903,867,894),//dc 1
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,4,6,11,11,12,18,19,13,15,16,15,53,94,108,153,85,122,198,164,277,462,574,576,536,562,522,528,592,622,629,646,566,546,559,573,592,595,601,601,609,611,620,627,639,646,653,657,665,668,669),//dc 2
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,4,6,8,8,9,8,12,16,37,47,56,72,96,135,181,248,299,354,463,567,691,792,861,920,996,1073,1180,1233,1287,1357,1415,1402,1427,1441,1548,1648,1707,1728,1875,2045,2138,2261,2306,2468,2620,2723,2889,3009,3053,3081),//dc 3
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,3,5,5,7,14,19,26,28,38,50,60,80,81,98,81,103,89,102,147,124,121,149,142,122,125,120,130,138,157,167,180,201,195,212,216),//dc 4
        new Array(0,0,0,0,0,0,0,1,1,3,4,6,7,10,9,12,13,14,17,20,21,22,13,27,40,47,61,57,67,68,69,72,67,65,75,76,71,82,85,83,104,107,97,101,102,105,107,114,121,104,109,113,127,138,142,145,139,147,152,167,233,243),//dc 5
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,5,5,6,7,7,8,8,11,9,11,11,10,12,15,15,16,16,18,23,21,21,21,26,27,26,28,32,33,35,46,48,50,62,66,74,83,85),//dc 6
        new Array(0,0,0,0,0,0,0,0,1,1,1,1,2,2,5,8,8,10,10,11,13,15,18,16,16,16,22,18,23,24,27,27,35,39,37,54,50,52,50,50,50,51,59,73,83,84,86,88,96,99,105,114,123,131,135,144,159,171,193,228,242,251),//dc 7
        new Array(0,0,0,0,2,2,6,9,13,13,6,7,7,8,14,17,19,22,37,45,49,60,87,93,105,129,145,165,192,212,237,251,284,315,351,380,392,434,471,510,545,635,725,759,897,1013,1176,1336,1572,1876,2213,2650,3015,3338,3630,3993,4361,4826,5200,5513,5820,5901),//dc 8
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,1,2,2,3,4,6,12,14,14,15,41,32,36,37,53,62,54,61,77,92,92,111,120,117,125,130,116,117,116),//dc 9
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,4,5,5,5,6,6,7,11,14,18,24,32,34,36,39,45,49,37,42,43,42,40,39,38,35,35,37,39,39,40,40,54,67,75,80,84,86,106,120,123,131,149,181,238,245),//dc 10
        new Array(0,0,0,0,0,0,0,0,0,1,3,5,7,9,12,15,16,14,18,19,27,33,47,96,147,164,181,96,114,138,172,240,319,365,364,310,339,361,409,481,541,588,642,574,605,710,848,1008,1195,1395,1648,2030,2347,2662,2889,3216,3505,3735,4036,4248,4480,4561),//dc 11
        new Array(0,0,0,2,3,3,7,11,14,13,7,8,8,10,15,17,21,23,28,29,29,30,31,36,41,48,53,64,73,88,94,98,107,107,119,125,115,119,132,141,148,154,162,122,137,140,152,152,156,161,156,167,171,168,171,174,178,188,193,196,203,203),//dc 12
        new Array(0,0,0,5,8,9,12,10,11,12,15,16,17,18,25,21,22,27,28,28,32,30,32,34,39,47,59,79,83,87,98,104,106,125,131,132,135,133,130,149,157,155,151,145,185,175,226,344,330,350,365,402,441,475,523,553,581,624,675,726,785,804),//dc 13
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,4,4,4,6,5,12,19,17,28,22,24,21,67,97,199,144,126,28,238,236,252,336,341,242,259,261,389,390,398,400,260,270,280,294,302,306),//dc 14
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,1,1,1,1,6,9,13,19,21,24,29,34,33,37,39,45,50,57,61,65,72,72,118,111,116,139,152,175,200,228,272,293,330,357,389,422,463,506,566,598,610),//dc 15
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,2,2,2,2,3,4,6,16,22,22,20,34,23,26,31,30,35,36,42,65,80,71,77,82,85,89,90,73,83,97,101,108,125,137,146,132,136,149,152,167,171),//dc 16
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,5,5,4,7,10,10,8,8,8,8,9,9,9,12,13,16,18,20,22,21,24,26),//dc 17
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,20,29,29,39,49,54,55,64,69,101,131,163,194,213,258,286,371,385),//dc 18
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,6,11,17,20,36,109,130,145,166,193,213,234,283,327,374,402,413),//dc 19
        new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,3,3,3,4,5,5,5,5)//dc 20
	);

var subNumberOfDecisions:Array = new Array(
	new Array( //directory code 01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,4,6,7,8), //subcode 01.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,2,3,4,2,2,3,3,2,2,2,2,2,4,4,5,5,6,6,7,9,13,12,23,35,42,43,42), //subcode 01.10
		new Array(0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,4,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,5,6,7,7,9,9,9), //subcode 01.20
		new Array(0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,8,8,9,11,9), //subcode 01.30
		new Array(0,0,0,1,1,1,1,1,2,2,5,7,7,8,8,8,8,10,10,11,13,15,17,25,26,28,34,39,43,42,46,63,77,72,83,73,77,76,77,86,86,89,98,118,135,186,236,259,210,239,301,307,231,299,374,460,346,428,511,589,508,532), //subcode 01.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,4,4,4,4,4,4,6,6,6,7,8,7,7,9,11,10,10,11,12,12,12,12,12,13,13,13,14,14,12,12,12,12,12,12,12,12,13,14,17,20,23,27,31,36,38,44,48,51,51), //subcode 01.50
		new Array(0,0,0,3,4,7,8,9,9,11,11,11,11,11,11,13,13,13,13,13,14,14,14,18,18,19,22,24,25,26,31,34,32,38,33,32,34,35,32,33,42,48,49,54,66,71,79,82,85,88,91,93,101,130,163,192,195,201,216,223,264,270) //subcode 01.60
		), //end directorycode-array (01)
	new Array( //directory code 02
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,3,4,4,4,4), //subcode 02.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1), //subcode 02.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,5,6,6,6,6,6,6,6,6), //subcode 02.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,37,68,75,110,16,18,29,42,69,84,105,75,30,38,18,17,47,76,79,82,14,11,11,11,14,14,13,12,12,12,13,14,14,14,16,16,16,16,16), //subcode 02.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,4,5,9,8,9,14,15,7,7,8,8,7,8,8,17,45,72,135,81,162,322,410,443,439,439,436,437,437,438,440,440,442,444,438,438,438,437,438,438,438,438,438,439,441,443,443,443,443,444,444), //subcode 02.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,3,4,4,6,7,7,5,8,17,22,23,17,25,26,32,37,45,48,47,54,68,44,48,77,77,80,94,79,54,67,80,89,91,96,96,104,106,109,112,122,127,130,133,138,139,140), //subcode 02.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0), //subcode 02.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,6,6,8,9,9,9,9,9,10,10,10,10,10,10,11,11,11), //subcode 02.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,6,6,8,9,9,11,11,11,12,15,21,24,29,29,29,29,30,35,37,37,41,42,43,43,43,44,45,48,48,48,49,49,51,52,52) //subcode 02.70
		), //end directorycode-array (02)
	new Array( //directory code 03
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,3,3,5,7,7), //subcode 03.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,7,17,11,11,13,16,17,20,20,23,23,22,23,29,29,30,27,30,29,29,33,38,41,51,56,61,65,65,76,83,97,104,115,119,110,111), //subcode 03.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,1,2,6,13,12,10,14,20,23,25,23,30,33,34,38,37,37,29,36,34,37,38,41,41,42,43,43,42,41,41), //subcode 03.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,6,19,36,38,52,57,73,95,108,116,118,114,113,115,122,122,127,132,117,126,140,144,152,152,134,141,147,152,157,162,171,178,187,205,224,226,230), //subcode 03.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,1,2,3,7,27,56,88,113,152,242,293,343,378,406,439,487,548,609,551,569,526,525,395,308,316,316,323,324,296,294,293,292,294,294,295,299,306,312,324,332,335), //subcode 03.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,3,4,4,4,4,5,5,5,5,5,4,4), //subcode 03.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,13,20,23,28,35,38,48,61,79,89,87,114,161,207,232,250,269,300,322,393,414,513,586,685,797,804,889,961,1032,1087,1203,1339,1411,1523,1533,1673,1795,1862,1991,2086,2158,2171), //subcode 03.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,3,4,7,7,8,7,10,13,22,26,30,40,53,63,70,83,101,108,131,150,175,185,193,199,207,197,210,236,255,275,280,294,297,302,315,334,323,307,324,354,365,370,373,376,393,410,425,435,414,421), //subcode 03.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,4,1,1,1,1,1,1,2,4,4,5,4,1,1,4,5,5,4,6,6,5,4,3,1,1,1,1,1,1,1,1,1,1,2,2,2,2), //subcode 03.70
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,5,9,15,17,21,23,27,32,36,40,39,38,44,45,35,36,39,39,37,39,39,41,42,45,50,53,55,59,59,57,57,59) //subcode 03.80
		), //end directorycode-array (03)
	new Array( //directory code 04
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,3,2,2,0,0,0,0,0,0,0,2,2,2,4,7,8,10,11,12,15,15), //subcode 04.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1), //subcode 04.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,3,2,6,9,11,16,18,27,33,37,58,59,68,51,72,59,70,109,86,88,108,106,82,86,69,77,86,99,104,111,128,121,129,132), //subcode 04.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,0,4,7,9,9,10,16,21,20,20,28,27,29,28,32,38,38,33,41,36,41,39,52,54,51,54,58,62,66,66,72,73) //subcode 04.20
		), //end directorycode-array (04)
	new Array( //directory code 05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1), //subcode 05.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,3,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,5,5,3,5,3,6,6,5,6,6,6,5,7,7,7), //subcode 05.10
		new Array(0,0,0,0,0,0,0,1,1,3,4,6,7,10,9,12,13,14,16,19,20,21,12,26,39,46,60,56,66,67,68,69,65,63,73,74,69,80,83,81,102,105,95,99,100,103,105,110,117,102,105,111,122,132,137,139,133,141,147,160,226,235) //subcode 05.20
		), //end directorycode-array (05)
	new Array( //directory code 06
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,2,2,2,2,2), //subcode 06.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,3,3,2,2,2,2,2,3,3,3,3,3,5,10,11), //subcode 06.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,4,4,5,5,8,6,8,7,6,6,9,9,9,8,9,12,11,11,11,12,12,13,15,19,19,21,29,30,30,38,39,40,39,40), //subcode 06.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,4,4,4,5,6,7,9,8,8,8,11,12,10,10,10,11,11,12,13,15,19,22,27,32,32) //subcode 06.30
		), //end directorycode-array (06)
	new Array( //directory code 07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,1,1,1,1,1,2,2,2,2,2,2,3,3,3), //subcode 07.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,3,3,3,3,4,4,4,4,4,5,5), //subcode 07.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,3,3,3,0,0,0,0,0,0,0,0,0,0,2,4,20,20,20,20,20,20,21,21,23,23,23,23,24,24,24,24,25,26,30,31,31,31,32,33,35,35,35), //subcode 07.10
		new Array(0,0,0,0,0,0,0,0,1,1,1,1,2,2,4,6,6,8,7,8,9,11,14,14,14,14,20,14,19,19,21,20,26,26,23,25,19,20,21,22,22,24,26,33,35,35,33,34,34,32,33,38,45,46,47,51,53,57,56,67,70,73), //subcode 07.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,2,4,4,5,5,6,8,10,9,8,10,10,7,6,7,6,7,11,12,11,15,15,17,19,23,24,25,26,27,31,34,35,37,45,50,51), //subcode 07.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,3,3,3,2,2,7,9,15,16,15,15,22,25,26,28,29,30,31,32,42,48,68,82,88,93) //subcode 07.40
		), //end directorycode-array (07)
	new Array( //directory code 08
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,3,4,4,5,5,9,14,16,19,21,20,20,19,19), //subcode 08.10
		new Array(0,0,0,0,0,0,4,7,11,11,4,4,4,5,11,14,15,16,26,36,39,49,69,70,78,93,101,113,131,142,157,153,164,175,183,205,208,224,239,247,256,267,276,281,297,298,296,292,282,296,297,301,299,304,309,311,317,322,318,318,317,316), //subcode 08.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,5,5,6,9,9,9,9,9,11,13,14,15,15,15,16,20,24,26,26,29,33,36,39,39,44,46,48,53,57,60,65,66,68,70,72,72,72,71,71), //subcode 08.30
		new Array(0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,3,4,5,5,4,4,5,8,16,18,20,23,25,27,30,31,31,31,32,30,31,31,32,39,96,154,209,294,389,511,629,845,1061,1327,1695,1978,2208,2457,2765,3061,3471,3785,4048,4319,4387), //subcode 08.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,3,3,3,3,4,6,6,15,14,15,16,16,17,17,17,17,17,17,17,17,17,17), //subcode 08.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,6,3,4,4,9,12,12,13,17,22,26,33,40,52,68,89,116,122,130,152,172,200,217,239,260,234,267,285,328,364,392,463,528,588,668,748,782,834,898,945,1009,1059,1095,1109), //subcode 08.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1), //subcode 08.70
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,3,3,3,4,5,5,6,7,10,8,8,8,10,11,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10), //subcode 08.80
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 08.90
		), //end directorycode-array (08)
	new Array( //directory code 09
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,3,3,3,3,3,3,4,5,5,5,5,6,5,6,6,6,6), //subcode 09.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,9,9,10,12,13,13,14), //subcode 09.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,2,3,5,11,12,12,13,37,27,31,31,47,56,45,53,67,81,81,92,97,93,100,101,86,87,85), //subcode 09.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,3,3,3,3,2,3,3,3,3,3,3,3,4,4,4,4), //subcode 09.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,4,4,4,4,4,7,7,7,8,8,8,8,8) //subcode 09.50
		), //end directorycode-array (09)
	new Array( //directory code 10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,4,4,6,5,6,6,6,6,5,6,6,6,12,12), //subcode 10.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1), //subcode 10.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,4,4,4,5,5,6,8,10,12,14,22,22,25,25,27,27,23,28,29,29,26,26,26,23,23,24,24,24,24,24,24,27,30,30,32,32,34,34,35,35,39,45,49,51), //subcode 10.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,3,4,6,10,10,11,10,13,17,21,12,13,13,12,13,12,12,12,12,13,14,14,15,15,28,39,46,50,53,56,70,79,82,88,104,130,177,183), //subcode 10.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,11,11,11,12,13,13,13) //subcode 10.40
		), //end directorycode-array (10)
	new Array( //directory code 11
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,4,4,4,6,6), //subcode 11.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,0,1,1,1,1,2,2,2,5,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1), //subcode 11.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,4,5,8,11,8,13,12,18,21,29,40,53,67,72,72,68,65,76,89,90,96,101,105,113,116,116,124,128,134,145,151,160,173,182,196,211,238,251,258,267,275,283), //subcode 11.30
		new Array(0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,4,4,4,3,6,9,15,21,68,116,123,134,42,53,68,88,129,171,201,177,142,161,162,190,269,318,324,362,298,314,418,545,682,831,997,1207,1554,1835,2111,2314,2631,2887,3088,3372,3558,3782,3851), //subcode 11.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,1,3,2,2,2,1,1,1,1,1,1,1,2,2,1,1,2,0,0,0,0,3,3,7,15,20,23,30,31,33,38,54,71,83,96,113,122,127,123,124,129,121,129,129,134), //subcode 11.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,2,3,4,4,6,7,8,8,7,11,10,15,14,19,18,28,27,31,29,31,39,57,67,91,83,95,108,111,104,102,122,130,123,125,119,122,137,157,164,189,200,204,224,229,227,240,249,266,271,269,272), //subcode 11.60
		new Array(0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,10,22,34,36,11,9,9,10,12,22,27,29,28,24,27,27,28,29,29,37,39,36,36,39,42,45,47,53,56,59,62,66,67,73,77,79,83,89,90,86) //subcode 11.70
		), //end directorycode-array (11)
	new Array( //directory code 12
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,3,3,3), //subcode 12.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,3,4,3,7,7,7,7,6,5,5,6,6,7,10,9,14,11,13,20,21,22,15,13,13,14,13,14,15,18,20,20), //subcode 12.10
		new Array(0,0,0,2,3,3,7,11,14,13,6,6,6,7,10,11,11,13,16,14,14,14,14,17,17,18,21,27,31,35,39,42,48,49,54,57,48,54,61,68,74,85,90,49,55,57,61,63,67,71,71,78,84,83,83,82,82,82,82,82,83,83), //subcode 12.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,2,2,4,4,12,12,10,10,10,11,13,17,17,17,18,18,15), //subcode 12.30
		new Array(0,0,0,0,0,0,0,0,0,0,1,2,2,3,5,6,10,10,11,14,14,15,16,18,23,29,31,34,38,41,44,44,46,46,49,52,51,49,56,57,58,51,54,54,60,62,65,66,62,51,45,50,54,56,58,59,59,67,71,69,72,74), //subcode 12.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,4,11,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,9,10,8,8,8,8,7,7,7,7,7,7,7,7,8), //subcode 12.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,1,1,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,3,5,5) //subcode 12.60
		), //end directorycode-array (12)
	new Array( //directory code 13
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,7,11,13,14,15,14,19,16,21,22,22,30,40,42,45,40,35,36,36,44,48,28,49,51,59,55,60,66,70,58,63,70,75,76,80), //subcode 13.10
		new Array(0,0,0,5,8,9,12,10,11,12,15,16,17,18,25,21,22,27,28,27,31,29,31,33,35,38,46,61,62,62,68,72,72,88,96,90,87,84,71,79,86,87,86,78,95,96,100,132,134,158,165,168,178,179,186,192,191,203,216,226,232,234), //subcode 13.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,4,7,9,13,11,13,16,17,20,18,18,20,25,26,28,29,30,24,25,27,31,34,70,151,155,131,142,168,195,225,257,279,316,339,364,401,450,461), //subcode 13.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,3,4,4,2,4,5,6,3,3,3,4,6,5,6,6,8,6,6,6), //subcode 13.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,20,5,10,11,10,13,14,17,27,25,23,23,23,26,30,31,35,38) //subcode 13.60
		), //end directorycode-array (13)
	new Array( //directory code 14
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,3,3,3,4,6,6,5,6,6,4,4,8,8,8,9,9,9,8,8), //subcode 14.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,5,2,2,3,2,2,2,4,3,3,5,4,5,4,4,4,4,4,4,5,4,5,5,5,5,6,6,6,6,6,5), //subcode 14.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,2,2,2,3,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,2,1,1), //subcode 14.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,5,7,5,7,7,8,8,8,8,8,8,8,8,8,8,8,10,10,11,11,11,11,9,9,9,9,9,9), //subcode 14.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,2,2,2,3,2,4,13,12,16,7,9,10,28,43,46,34,25,9,9,10,10,10,10,10,10,10,10,10,10,10,11,10,10,10,10,10), //subcode 14.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,6,8,2,29,42,141,95,86,3,198,211,225,307,312,214,227,230,358,359,363,365,225,235,245,259,269,274), //subcode 14.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1) //subcode 14.60
		), //end directorycode-array (14)
	new Array( //directory code 15
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,3,3,4,4,4,4,4,4,4,4), //subcode 15.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,5,8,12,16,18,21,27,31,31,35,37,42,45,52,56,54,59,60,103,95,94,112,120,138,157,175,215,236,259,276,304,322,332,352,385,400,409), //subcode 15.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,1,0,0,0,1,1,1,2,2,0,0,2,1,1,1,2,4,2,3,5,6,5,10,15,19,24,24,25,31,42,56,63,73,77,87,99,127,151,180,188,184), //subcode 15.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,0,0,0,0,0,1,0,3,4,3,4,4,8,13,16,21,25,32,34,32,38,43,43,47,56,59,68,74,77), //subcode 15.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,2,2,3,3,4,4,4,4,4,5,8,9,9,9,9,10,10,10,11,11,11,11,11,11) //subcode 15.40
		), //end directorycode-array (15)
	new Array( //directory code 16
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,5,4,4,4), //subcode 16.01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,3,3,5,3,3,3,3,4,4), //subcode 16.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,11,14,13,8,14,14,16,20,17,20,18,23,33,41,31,27,28,28,30,32,9,22,24,25,20,24,27,29,31,34,38,39,42,44), //subcode 16.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,5,6,1,2,2,3,4,4,6,8,7,5,6,11,13,18,20,21,25,32,30,34,41,47,48,51,50,54,57,65,66), //subcode 16.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,2,2,2,2,3,3,5,6,7,6,7,14,9,9,10,11,12,15,14,25,33,37,46,44,44,40,33,37,32,36,41,48,52,52,53,32,31,34,33,38,39), //subcode 16.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,6,7,5,6,6,7,8,12,14,15,17,19,21,24,24) //subcode 16.40
		), //end directorycode-array (16)
	new Array( //directory code 17
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,5,3,5,6), //subcode 17.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,5,5,4,7,10,10,8,8,8,8,9,9,9,12,12,13,14,16,16,16,16,17), //subcode 17.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,3,3) //subcode 17.30
		), //end directorycode-array (17)
	new Array( //directory code 18
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,20,29,29,39,49,54,55,64,69,101,131,163,194,213,258,286,370,384) //subcode 18.00
		), //end directorycode-array (18)
	new Array( //directory code 19
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1), //subcode 19.01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,6,10,13,15,65,67,74,78,91,100,107,132,159,184,197,204), //subcode 19.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,4,5,8,11,14,17,24,25,26), //subcode 19.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,6,6,19,35,45,53,68,80,87,100,122,138,154,166,168), //subcode 19.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,8,17,17,18,21,22,23,25,30,34,39,40), //subcode 19.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,3,5,5,6,6,10,13,16,16) //subcode 19.50
		), //end directorycode-array (19)
	new Array( //directory code 20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 20.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 20.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,3,3,3,4,5,5,5,5) //subcode 20.20
		) //end directorycode-array (20)
); //end full sub directive array

var subNumberOfDirectives:Array = new Array(
	new Array( //directory code 01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 01.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,3,3,3,3,5,5,5,18,18,18,18,16), //subcode 01.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 01.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0), //subcode 01.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1), //subcode 01.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 01.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1) //subcode 01.60
		), //end directorycode-array (01)
	new Array( //directory code 02
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 02.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 02.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,2,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 02.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 02.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2), //subcode 02.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,4,6,8,9,12,13,14,20,21,26,27,26,30,33,38,38,38,39,25,17,17,18,19,14,15,7,7,7,8,8,8,9,10,10,10,10,11,11,11,11,11,11,11), //subcode 02.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,3,3,3,3,4,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,7,7,5,6,6,6,7,4,4,4,3), //subcode 02.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 02.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 02.70
		), //end directorycode-array (02)
	new Array( //directory code 03
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1), //subcode 03.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,4,5,6,7,8,9,9,11,13,13,14,14,20,20,22,22,22,23,23,25,16,16,17,10,11,11,12,12,7,7,8,8,8,9,6,6,6,6), //subcode 03.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 03.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,4,4,4,4,5,6,6,6,7,8,8,9,9,9,9,9,9,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8), //subcode 03.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,10,12,21,24,26,30,36,38,43,46,47,48,46,50,50,50,51,52,54,56,56,56,57,58,55,56,56,56,56,56,56,56,56,56,56,56,56,56,56), //subcode 03.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 03.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,9,10,11,20,25,31,41,49,65,73,83,92,108,124,153,164,179,187,195,165,183,203,221,237,258,265,289,322,342,364,374,360,357,368,348,361,360,382,394,412,444,484,505,525,553,475), //subcode 03.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,2,4,8,10,12,12,12,13,19,24,24,25,26,27,27,26,28,29,30,32,32,32,35,39,38,38,40,37,38,41,44,47,51,50,48,53,57,66,65,66,68,68), //subcode 03.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 03.70
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 03.80
		), //end directorycode-array (03)
	new Array( //directory code 04
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 04.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 04.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2), //subcode 04.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 04.20
		), //end directorycode-array (04)
	new Array( //directory code 05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1), //subcode 05.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,1,2,2,1,1,1,1,2,2,2,2,3,4,4,4,4,5,5,5,5,5,6,6,6,6,6,6,6,7,7,7,8,7,8,9,9,10,10,11,12,13,13,13,14,15,12,5,5,5,5,5), //subcode 05.10
		new Array(0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,3,4,4,4,4,4,4,4,5,6,10,12,14,15,18,22,21,23,24,25,25,28,30,33,38,43,48,54,55,57,58,61,67,75,76,70,68,73,79,78,81,81,82,82,79,83,82) //subcode 05.20
		), //end directorycode-array (05)
	new Array( //directory code 06
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1), //subcode 06.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,5,5,6,6,7,9,9,11,12,12,13,14,14,15,15,18,17,9,9,9,9,9), //subcode 06.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,3,10,12,12,17,26,28,31,32,33,37,41,44,45,51,56,58,64,66,71,72,74,82,89,93,95,105,110,117,121,120,124,127,123,128,139,106,95,91,94,97,100,103,106,86,97,99,103,97), //subcode 06.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,4,4,4,4,4,5,6,6,7,7,7,7,7,7,7,7,8,8,10,10,12,10,10,10,10,11,12,11,11,12,12,12,13,15,11,11,12,13,13,13) //subcode 06.30
		), //end directorycode-array (06)
	new Array( //directory code 07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1), //subcode 07.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1), //subcode 07.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,2,2,3,3,3,3,3,3), //subcode 07.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,3,3,3,3,4,5,5,6,8,11,14,15,20,20,24,26,27,29,32,32,35,41,44,50,55,59,60,65,70,65,57,68,77,84,88,95,102,105,107,110,115,114,118,115), //subcode 07.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,4,4,4,4,4,4,4,4,4,5,5,5,7,11,14,22,26,28,28,35,39,36,42,43,44,45,47,44,44), //subcode 07.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,4,4,4,5,6,6,8,4,5,6,7,7,7,8,9,10,11,11,11,12,11,12,10,11,11,11,12,11,11) //subcode 07.40
		), //end directorycode-array (07)
	new Array( //directory code 08
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,2,2,3,3,3,4,5,5,8,8,8,9,10,10,11,6,6,7,3,3,2,2,2,2), //subcode 08.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,1,2,0,1,1,1,0,1,2,2,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1), //subcode 08.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.70
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.80
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1) //subcode 08.90
		), //end directorycode-array (08)
	new Array( //directory code 09
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1), //subcode 09.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,4,6,7,7,7,7,6,6,6), //subcode 09.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,3,6,6,7,10,12,15,15,15,19,24,27,30,33,34,41,42,45,47,48,51,55,56,59,64,64,64,62,63,65,67,71,74,75,79,81,87,88,61,64,65,63,69,70), //subcode 09.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 09.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,4,4,5,7,7,8,8,9,9,9,10) //subcode 09.50
		), //end directorycode-array (09)
	new Array( //directory code 10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 10.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 10.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 10.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0), //subcode 10.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,3,4,4,5,6,2,3,3,4,3,3,3,5,6,6,6,8,9,10,10,10,11,12,12,13,13,13) //subcode 10.40
		), //end directorycode-array (10)
	new Array( //directory code 11
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 11.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 11.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,2,3,3,3), //subcode 11.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 11.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 11.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,4,3,3,3,3,3,4,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3), //subcode 11.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 11.70
		), //end directorycode-array (11)
	new Array( //directory code 12
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,2,3,4,4,4,4,4,4,4,2), //subcode 12.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,3,4,4,5,5,6,7,7,8,7,7,9,8,8,10,10,10,11,11,11,9,9,9,8,9,10,10,10,11,12,12,11,11), //subcode 12.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 12.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,4,5,5,6,4,4,5,5,6,7,7,3), //subcode 12.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 12.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,3,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,8,8,8,7,9,7,7,7,7,8,6,6,6,6,6,9,9,8), //subcode 12.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1) //subcode 12.60
		), //end directorycode-array (12)
	new Array( //directory code 13
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,5,4,4,4,4,4,2,2,2,2,2,2,2,3,3), //subcode 13.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,2,2,1,2,0,2,2,2,4,7,10,11,12,13,14,15,16,18,19,19,25,14,14,15,16,16,15,19,19,19), //subcode 13.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,6,12,13,16,20,34,47,54,64,86,105,141,161,196,219,240,261,288,313,335,348,375,404,438,480,510,540,566,613,629,620,649,662,677,713,745,742,752,745,783,803,813,841,857,804,811,806), //subcode 13.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,2,2,2,2,2,2,2,2,2,3,4,4,4,4,5,5,5), //subcode 13.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,2,3,3,3,4,4,4,5,5,5,6,6,7,5,5) //subcode 13.60
		), //end directorycode-array (13)
	new Array( //directory code 14
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,5,5,6,8,8,8,8,8,8,7,7,8,8,7,8,5,5,5,5), //subcode 14.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 14.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 14.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 14.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 14.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 14.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 14.60
		), //end directorycode-array (14)
	new Array( //directory code 15
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,2,2,2,2,3,3,3,3,3,3,4,4,4,3,3), //subcode 15.07
		new Array(0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,2,3,3,3,3,4,4,5,8,9,12,18,21,27,35,40,46,53,60,72,87,94,103,112,121,131,142,148,154,159,158,164,175,181,190,191,202,184,200,206,204,213,216,226,187,180,179), //subcode 15.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,8,8,8,10,13,14,20,21,22,25,27,36,42,45,52,54,56,59,66,71,77,67,69,80,87,92,96,102,107,111,62,64,64), //subcode 15.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,2,2,2,2,3,3,3,4,6,6,6,6,7,8,9,10,13,14,17,20,23,25,26,26,27,26,27), //subcode 15.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,5) //subcode 15.40
		), //end directorycode-array (15)
	new Array( //directory code 16
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 16.01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 16.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1), //subcode 16.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,3,3,3,4,4,4,4,5,5,6,6,6), //subcode 16.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,4,4,4,7,10,10,10,11,13,13,14,12,13,13,13,14,14,15,16,16,16,16,16,17,17,2,2,2,2,2), //subcode 16.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 16.40
		), //end directorycode-array (16)
	new Array( //directory code 17
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,2,3,5,5,5,5,6,7,9,8,8,8,8,8,14,14,15,15,16,16,16,16,16,17,17,19,19,23,26,28,30,32,33,32,32,33), //subcode 17.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,3,4,6,6,6,7,7,9,9,9,11,11,11,12,12,12,12,12,12,12,12), //subcode 17.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2) //subcode 17.30
		), //end directorycode-array (17)
	new Array( //directory code 18
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1) //subcode 18.00
		), //end directorycode-array (18)
	new Array( //directory code 19
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 19.01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,3,4,4,4,4,4,4,4,4,7,8,11,16,18,16,16,17,20,20,21), //subcode 19.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1), //subcode 19.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,3,3,2,3,1,1,1,1,1,2,3), //subcode 19.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2), //subcode 19.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 19.50
		), //end directorycode-array (19)
	new Array( //directory code 20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 20.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,3,3,3,3,3,3,3,3,3,3,3,4,4,1,1,1,1,1,1), //subcode 20.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,3,3,3,3,4,4,4,4,4,4,4,5,5,5,5,5) //subcode 20.20
		) //end directorycode-array (20)
); //end full directives sub array


var subNumberOfRegulations:Array = new Array(
	new Array( //directory code 01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,5,5,6,10,11,11,10,11,12,12,13,15,17,17,17,18,29,41,44,58,82,90), //subcode 01.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,5,5,5,6,10,18,16,28,28,30,29,29), //subcode 01.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,3,4,4,4), //subcode 01.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2), //subcode 01.30
		new Array(0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,4,6,7,8,9,9,11,11,11,13,14,14,14,14,15,16,16,16,16,15,15,15,16,17,18,20,22,23,27,27,28,33,38,43,45,48,53,59,63,67,69,74,80,84,85), //subcode 01.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,5,9,13,17,19,19,11,14,15,15,21,26,26,29,34,35,40,42,45,47,55,54,54,63,62,71,74,78,77,83,90,93,100,103,106,112,121,122,126,126,133,138,141,146,153,157,164,169,175,175), //subcode 01.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,3,5,6,6,7,10,13,15,16,18,17,18,19,20,22,24,24,24,27,27,27,22,28,34,37,38,39,40,42,44,30,35,37,44,43,52,55,54,55,55) //subcode 01.60
		), //end directorycode-array (01)
	new Array( //directory code 02
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,2,2,2,2,2,2,2,4,3,5,6,7,7,7,7,7,7,7,7,7,5,5,5,5,5,5,5), //subcode 02.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,4,6,6,6,8,9,11,11,13,13,16,26,57,78,104,126,127,141,147,159,164,174,186,189,192,192,196,207,223,237,247,251,253,268,276), //subcode 02.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,8,8,10,12,13,12,13,13,14,17,21,21,21,22,3,3,7,16,17,24,27,31,35,37,38,41,45,48,50,54,51,51), //subcode 02.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,6,8,18,18,33,41,46,60,55,71,82,107,165,175,203,198,153,182,157,173,201,240,240,242,195,119,116,133,146,156,176,193,210,227,241,252,267,295,323,347,367,389,402), //subcode 02.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,24,40,40,47,49,57,59,68,73,81,105,127,145,146,169,190,205,220,191,221,265,282,293,324,329,283,295,331,373,420,439,471,493,528,549,576,555,590,622,638,588,567,562), //subcode 02.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,8,14,24,34,39,59,62,79,85,97,106,108,116,131,120,122,128,132,129,137,143,60,57,62,74,75,81,80,87,92,92,92,91,94,96,97,99,98,97), //subcode 02.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,3,2,2,2,2,2,2,2,2,2,2,3,4,4,4), //subcode 02.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,3,5,5,5,5,6,3,5,5,6,6,7,7,8), //subcode 02.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,3,3,4,4,5,6,6,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5) //subcode 02.70
		), //end directorycode-array (02)
	new Array( //directory code 03
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,5,6,10,18,26,34,49,60,72,88,110,122,129,156,201,268,368,393), //subcode 03.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,3,5,7,8,10,12,13,14,13,18,21,27,27,31,33,34,38,40,45,46,53,62,66,67,63,66,64,62,64,77,89,86,87,92,94), //subcode 03.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,3,5,6,6,8,10,10,16,24,40,55,64,86,71,83,77,92,94,123,122,90,92,91,99,98,99,106,101,93,96,90,81,83,79,84,91,98,103,102,106,111,111,97,83), //subcode 03.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,2,5,5,7,7,9,18,25,27,35,40,45,47,53,66,87,93,93,60,73,86,80,81,79,85,88,97,89,107,107,124,131,141,147,153,167,164,149,161,164,177,187,215,236,277,300,280,264,268), //subcode 03.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,5,7,8,12,13,14,18,19,20,25,30,39,41,52,65,69,80,80,82,94,100,113,128,133,112,127,157,150,165,174,174,185,166,175,173,171,188,200,223,233,260,282,260,229,230), //subcode 03.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,3,3,3,7,9,15,17,23,32,43,65,77,94,82,93,77,75,40,55,58,62,71,96,105,98,63,68,84,84,104,99,108,118,130,138,147,151,162,158,160,165,159,152,145), //subcode 03.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,0,1,2,4,6,4,4,8,16,21,23,38,63,95,125,146,167,198,247,300,345,403,472,546,618,699,720), //subcode 03.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,1,24,33,40,44,50,81,168,252,337,419,505,604,674,765,880,1006,1215,1393,1532,1652,1762,1868,1963,2047,2341,2565,2660,2692,2802,3046,3201,3151,3276,2959,2979,3040,3151,2971,2783,2633,2686,2729,2667,2777,2859,3002,2936,2718,2526,2528), //subcode 03.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,3,11,12,14,19,25,28,31,41,45,53,62,51,59,59,70,64,79,95,112,131,132,137,145,160,155,158,143,116,128,145,158,104,96,109,108,109,110,105,108,108,110,97,68), //subcode 03.70
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,5,11,14,15,16,17,19,18,15,18,16,16,17,17,18,16,16,16,17,15,23,19,19,21,23,19,20,20,20,20,21,21,21,21,19,19,18) //subcode 03.80
		), //end directorycode-array (03)
	new Array( //directory code 04
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,2,3,3,3), //subcode 04.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,5,7,8,10,10,8,8,7,10,10,10,10,11,11,11,11,11,11,11), //subcode 04.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,10,14,16,22,26,36,42,51,46,59,44,38,61,71,80,113,123,133,149,171,206,218,220,218,238,239,222,232,247,198,223,219,291,369,440,517,617,728,768,837,865), //subcode 04.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,5,10,12,12,17,21,22,24,31,36,33,40,43,43,48,48,54,53,56,64,60,59,61,64,65,69,71,73,75,81,83,83,84) //subcode 04.20
		), //end directorycode-array (04)
	new Array( //directory code 05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,3,2,2,1,1,1,1,2,2,2,4,8,14,14,18,27,30,36,36,39,42,46,50,51), //subcode 05.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,5,6,7,7,7), //subcode 05.10
		new Array(0,0,0,0,0,0,0,0,0,1,2,2,3,9,15,17,17,19,19,19,20,19,6,8,10,11,15,17,23,24,25,31,21,18,20,21,24,27,31,34,34,34,32,37,40,43,44,36,37,39,42,45,50,61,65,74,78,89,98,108,114,125) //subcode 05.20
		), //end directorycode-array (05)
	new Array( //directory code 06
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,3,4,5,6,7,8,8), //subcode 06.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,3,4,4,4), //subcode 06.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,4,6,8,8,8,9,9,11,14,14,15,15,16,17,17,19,22,22,25,29,28), //subcode 06.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,2,2,2,2,3,4,6,6,7,7,9,9,10,10) //subcode 06.30
		), //end directorycode-array (06)
	new Array( //directory code 07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,3,3,3,3,4,5,5,5,6,4,7,7,6,6,6,6,6,6,6,6,6,7,7,7,9,9,8,9,8,8), //subcode 07.05
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,3,3,8,9,10,11,16,16,17,18,18), //subcode 07.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,4,5,5,6,6,7,9,9,11,12,13,13,14,13,12,13,12,12,12,12,13,13,13,12,12,12,13,13,13,13,13,13,14,14), //subcode 07.10
		new Array(0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,3,5,4,10,15,17,18,21,26,27,30,28,24,33,35,35,35,37,39,39,40,37,39,40,43,48,55,49,37,43,48,52,56,64,55,59,58,62,66,68,71,78,81,83,89,104,102), //subcode 07.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,3,3,3,3,4,4,4,4,4,4,4,4,7,7,8,9,9,12,14,14,15,17,17,18,16,15,15,19,22,23,25,27,33,35,38,43,43), //subcode 07.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,7,10,13,16,18,19,19,21,21,21,24,25,27,27,37,45,49,68,87,100,114,131,136) //subcode 07.40
		), //end directorycode-array (07)
	new Array( //directory code 08
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,5,7,7,8,8,8,9,9,9,9,12,13,13,15,15,15,16,16,16,16,13,12,12,14,14,14,14,15,15,16,16,17,18,16,14,14,14,15,14,15,16,17,17,17,18,18,19,20,21,23), //subcode 08.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,2,1,4,4,5,5,6,11,12,12,13,16,15,16,17,19,21,20,16,13,14,12,13,12,13,13,13,13,11,7,7), //subcode 08.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,3,4,4,4,4,4,4,4,4,4,4,4,5,3,3,2,2,2,2,2,2), //subcode 08.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,3,3,3,3,4,3,3,3,3,3,2,2,2,2,3,3,3,3), //subcode 08.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,4,7,10,11,12,14,14,16,17,17,22,23,22,25,26,28,27,27), //subcode 08.60
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1), //subcode 08.70
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 08.80
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 08.90
		), //end directorycode-array (08)
	new Array( //directory code 09
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 09.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 09.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,5,6,7,7,8,8,8,8,9,7,11,14,15,15,18,19,20,19), //subcode 09.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,2,2,3,1,2,2,2,2,2,1,1,1,1,2,4,4,4,4,5,5,5), //subcode 09.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,4,4,4,4,4,4,4,4,4,4,4,4,4) //subcode 09.50
		), //end directorycode-array (09)
	new Array( //directory code 10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,4,5,7,9,15,28,35,41,49,58,63,72,73,78,79,79,82,82), //subcode 10.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 10.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,8,9,9,9,9,9,9,10,11,12,12,14,10,10,10,9,9,9,9,9,8,8,7,7,7,9,12,14,15,17,20,19,20,19,22,24,30,31,31), //subcode 10.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,4,8,8,7,7,4,6,0,0,0,1,1,1,1,0,0,3,4,7,9,14,22,28,35,39,40,44,48,49,54,59,64,72,74), //subcode 10.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,4,4,3,5,6,8,12,15,15,14,15,17,18,19) //subcode 10.40
		), //end directorycode-array (10)
	new Array( //directory code 11
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,3,3,3,4,4,3,4,4,1,1,1), //subcode 11.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,6,5,5,5,5,7,7,7,7,7,5,7,5,5,5,5,5,5), //subcode 11.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,4,5,21,35,57,43,50,60,46,22,21,23,22,20,21,19,22,23,26,26,25,29,30,32,43,46,46,56,69,88,99,104,107,149,153), //subcode 11.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,7,15,34,42,54,71,88,115,123,168,230,189,201,219,207,169,193,205,198,212,188,187,183,158,163,163,165,181,179,187,188,196,218,227,234,254,260,268,264,263,261), //subcode 11.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,5,7,8,5,16,18,10,23,31,25,22,17,8,8,6,8,18,59,70,75,81,80,83,84,89,93,102,109,111,115,118,124,118,119,120,113,115,115), //subcode 11.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,10,15,17,27,32,33,42,54,59,69,96,134,147,187,216,218,190,212,233,256,260,276,284,314,307,342,329,341,383,399,472,472,497,565,600,608,640,645,662,661,607,573), //subcode 11.60
		new Array(0,0,0,0,0,0,0,0,0,3,3,4,5,5,5,6,6,6,6,7,7,7,9,20,33,38,48,25,28,28,27,30,38,43,41,41,63,83,101,102,80,96,65,65,68,65,62,70,73,69,70,73,77,78,84,91,72,76,78,80,81,81) //subcode 11.70
		), //end directorycode-array (11)
	new Array( //directory code 12
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2), //subcode 12.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,3,4,4,6,5,7,7,7,7,8,8,11,8,8,8,8,7,8,8,8,8,7,7,6,7,5,5,6,6,6,6,6,6,6,6,6,21,25,26), //subcode 12.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0), //subcode 12.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,2,2,2,2,2,3,4,2), //subcode 12.30
		new Array(0,0,0,0,0,0,0,0,3,5,6,6,6,6,6,6,7,7,7,7,7,7,7,7,8,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,13,13,13,13,13,13,13,13,13,13,15,15,13,12,14,14,14,15,15), //subcode 12.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,4,7,8,8,8,12,13,13,13,14,14,13,13,13,13,12,14,8,8,8,8,9,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,2), //subcode 12.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,5,5,6,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1) //subcode 12.60
		), //end directorycode-array (12)
	new Array( //directory code 13
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,3,3,1,2,1,2,2,1,1,1,3,2,2,3,2,6,9,9,10,11,15,17,17,20,19,21,25,27,28,35,44,53,58,58), //subcode 13.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,6,26,42,23,13,5,2,1,1,2,2,2,2,1,1,7,10,11,12,11,11,11,13,16,15,21,20,23,30,33,36,39,39), //subcode 13.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,2,5,2,4,8,9,16,19,22,26,26,31,32,39,46,50,54,65,84,116,165,251,282), //subcode 13.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,11,11,12,15,21,24,33,36,40,45,61,69,70), //subcode 13.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,2,3,4,5,6,6,6,3,3) //subcode 13.60
		), //end directorycode-array (13)
	new Array( //directory code 14
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,3,4,4,6,6,6,8,9,13,22,26,26,33,34,34,37,38,42,43,44,48,48), //subcode 14.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,5,5,2,5,5,6,6,4,6,5,6,5,6,6,6,5,5), //subcode 14.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,3,3,4,4,4,4,3,4,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,6,6), //subcode 14.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 14.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,2,7,7,9,12,14,18,19,19,20,20,19,17,16,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15), //subcode 14.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,7,12,13,13,18,16,20,21,23,20,13,15,19,17,23,28,32,38,44,51,67,67,72), //subcode 14.50
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,4,4,5,6,7,8,6,2,2,2,2,2) //subcode 14.60
		), //end directorycode-array (14)
	new Array( //directory code 15
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,3,3,3,3,3,5,5,4,4,4,2,2,5,9,10,11,10,12,13,13), //subcode 15.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,5,9,6,9,14,16,22,19,18,19,30,33,38,39,50,55,54,65,71,70,75,86,96,100,111,136,149,168,181), //subcode 15.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,2,1,5,9,9,12,17,27,34,36,40,55,73,89,114,134,156,187,226,248,268,293,310,390,522,550), //subcode 15.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,7,7,9,10,12,13,13,17,20,20,19,20,18,17,14,15,18,19,20), //subcode 15.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,3,5,7,7) //subcode 15.40
		), //end directorycode-array (15)
	new Array( //directory code 16
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 16.01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,4,4,5,6,8,8), //subcode 16.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,4,4,4,4,6,8,8,8,6,6,6,6,6,6,7,7,8,8), //subcode 16.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,3,2,3,3,3,2,2,2,2,2,2,2,2,3,4,5,6,6,6,6,7,10,16,24,33,38,45,54,64,75,77), //subcode 16.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,4,5,7,7,7,8,8,8,8,8,11,12,13,14,14,15,13,15,15), //subcode 16.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 16.40
		), //end directorycode-array (16)
	new Array( //directory code 17
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,4,7,16,19,22,29,45,52,53), //subcode 17.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,10,13,14,15,16,16,16,20,23,27,30,31,32,38,35,35,35), //subcode 17.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,3,3,3,3,3,3,3,3,3,3,2,2,3,6,6,7,8,10,13,12,13,15,17,19,23,23,23) //subcode 17.30
		), //end directorycode-array (17)
	new Array( //directory code 18
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,4,6,9,17,21,33,36,65,97,144,175,210,237,267,307,320) //subcode 18.00
		), //end directorycode-array (18)
	new Array( //directory code 19
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0), //subcode 19.01
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,1,1,2,3,7,12,19,25,29,28,31,35,40,42,43), //subcode 19.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,7,9,12,14,16,18,23,24,24), //subcode 19.20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,5,5,6,6,7,7,7,9,15,15,17,17,19,21,16,18,22,24,24), //subcode 19.30
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,3,3,3,4,5,7,8,10,10), //subcode 19.40
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) //subcode 19.50
		), //end directorycode-array (19)
	new Array( //directory code 20
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0), //subcode 20.07
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2), //subcode 20.10
		new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1) //subcode 20.20
		) //end directorycode-array (20)
); //end full regulation array

			
var circleSubRadius:Array = new Array(  //For hver cirkel et array med hver subcode og for hver subcode radius for hvert aar
    new Array( //directory code 01
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,5,5,6,10,11,11,10,11,12,12,13,15,17,18,19,20,32,44,48,64,89,98), //subcode 01.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,2,2,2,2,3,2,3,4,5,7,8,6,8,12,11,10,11,12,17,21,26,31,36,43,46,47,50,58,72,69,107,120,129,130,127), //subcode 01.10
                new Array(0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,5,5,5,6,6,7,9,11,10,11,11,11,12,12,12,13,17,17,19,19,20,20,21,24,24,24,24,24,24,27,30,32,34,35,39,39,39), //subcode 01.20
                new Array(0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,4,5,5,7,8,8,8,9,9,9,9,10,10,10,10,10,10,10,10,10,10,11,11,11,11,9,11,11,11,11,11,11,11,11,11,11,12,11,12,12,14,16,14), //subcode 01.30
                new Array(0,0,0,2,3,3,4,5,9,8,14,16,17,19,19,20,22,28,30,34,36,39,42,52,55,55,63,70,76,76,81,102,120,118,130,120,120,122,123,135,136,138,150,169,192,252,308,344,306,356,436,453,384,463,544,642,542,629,729,826,767,795), //subcode 01.40
                new Array(0,0,0,0,0,0,2,2,2,2,2,2,6,13,17,21,23,23,15,21,22,22,29,35,34,37,44,47,51,53,57,60,68,67,67,76,77,86,89,94,92,96,103,106,115,118,121,127,136,142,150,154,162,170,176,185,197,202,215,224,233,233), //subcode 01.50
                new Array(0,0,0,4,5,8,9,10,10,12,12,13,13,13,14,16,17,18,18,18,19,19,24,29,29,31,36,41,44,48,55,63,61,68,67,68,73,76,78,79,91,100,100,102,124,138,156,166,192,204,232,242,239,274,309,345,345,362,385,391,434,440) //subcode 01.60
                ), //end directorycode-array (01) 
        new Array( //directory code 02
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,3,4,4,4,4,4,5,5,6,6,6,6,7,6,8,7,9,10,12,13,13,13,13,14,14,15,15,13,13,14,15,15,15,15), //subcode 02.05
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,4,6,6,6,8,9,12,13,15,15,18,29,60,81,107,129,130,142,148,160,166,176,188,191,194,194,198,209,225,239,249,253,255,270,278), //subcode 02.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,4,4,4,4,4,5,6,12,12,14,16,17,16,17,17,18,18,22,22,21,23,5,4,9,18,19,26,29,33,37,43,45,48,52,55,57,61,58,58), //subcode 02.10
                new Array(0,0,0,0,0,0,0,0,0,2,3,5,5,5,5,5,5,5,8,11,15,25,26,76,116,128,181,93,107,130,163,249,274,324,282,197,235,187,202,259,327,330,334,219,137,134,151,168,179,197,214,231,248,263,275,290,318,349,373,393,416,429), //subcode 02.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,5,6,11,10,11,16,20,32,48,49,57,58,67,69,87,120,155,243,211,310,471,583,637,649,664,632,662,706,724,737,768,777,735,741,778,821,867,887,916,941,976,997,1025,1006,1046,1078,1094,1044,1024,1021), //subcode 02.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,4,10,11,12,13,12,18,21,23,24,47,75,100,119,131,180,176,200,223,249,271,272,284,326,276,281,330,340,341,358,358,199,216,238,262,265,277,283,300,308,311,315,325,333,338,342,347,347,347), //subcode 02.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,3,4,5,5,5,5,5,5,6,7,8,8,9,9,9,9,9,9,9,9,10,9,9,10,11,10,8,9,9,9,10,8,9,9,8), //subcode 02.50
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,8,8,10,13,15,15,15,15,17,14,16,17,18,19,22,22,23), //subcode 02.60
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,10,11,14,15,18,21,22,24,25,30,45,50,55,56,55,55,56,65,68,68,78,80,82,82,82,85,87,91,91,91,92,92,94,96,96) //subcode 02.70
                ), //end directorycode-array (02)
        new Array( //directory code 03
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,4,8,8,9,13,21,29,37,52,63,75,91,114,126,134,162,207,276,378,418), //subcode 03.05
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,6,7,11,15,27,24,27,30,37,42,46,48,50,61,63,72,78,82,86,84,93,85,90,96,101,114,128,135,136,138,136,146,155,182,203,208,213,209,212), //subcode 03.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,3,5,6,7,10,11,11,18,26,43,58,67,89,75,86,81,100,109,138,135,108,116,119,129,126,134,144,140,136,138,132,115,124,117,125,133,143,148,149,154,159,158,143,129), //subcode 03.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,2,6,6,8,10,12,21,29,31,43,48,54,62,81,112,134,158,159,144,181,210,215,218,213,217,222,238,227,250,255,257,274,299,309,325,341,321,314,332,340,358,373,410,438,488,529,528,514,523), //subcode 03.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,5,9,9,11,12,17,18,24,35,47,77,114,153,191,238,342,410,467,515,544,577,641,708,782,740,763,701,718,617,523,547,557,561,574,527,536,533,530,549,561,585,599,633,661,651,628,632), //subcode 03.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,1,1,1,3,3,4,8,11,16,18,24,33,44,66,78,96,83,95,79,77,42,57,60,64,74,99,108,101,66,71,87,87,107,102,112,123,136,144,153,157,169,165,167,172,166,158,151), //subcode 03.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,9,10,13,23,39,52,66,79,110,123,143,165,199,225,253,292,354,409,443,430,467,519,560,650,691,797,898,1038,1176,1207,1320,1404,1507,1607,1726,1899,2006,2193,2278,2487,2703,2882,3106,3293,3478,3466), //subcode 03.50
                new Array(0,0,0,0,0,0,0,0,0,0,0,1,28,38,48,52,59,90,181,271,367,457,551,663,750,877,976,1119,1358,1550,1716,1852,2001,2109,2211,2301,2605,2822,2931,2994,3127,3393,3563,3527,3656,3348,3383,3462,3565,3373,3207,3092,3162,3209,3148,3268,3376,3546,3496,3291,3083,3104), //subcode 03.60
                new Array(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,4,5,13,14,16,21,27,31,37,44,48,56,65,54,62,63,76,70,86,101,115,134,138,145,153,166,163,166,150,122,133,148,161,107,99,112,111,112,113,108,111,112,114,101,72), //subcode 03.70
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,4,4,4,5,5,5,7,8,15,26,41,35,34,46,64,82,83,104,98,114,130,142,154,153,152,157,153,142,142,146,149,148,154,145,152,154,154,167,171,175,178,179,173,173,174) //subcode 03.80
                ), //end directorycode-array (03)
          new Array( //directory code 04
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,3,4,4,4,4,5,4,4,3,3,4,5,5,4,6,7,6,6,8,11,12,15,16,18,21,21), //subcode 04.05
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,5,7,8,10,10,8,8,7,10,10,10,10,12,11,11,11,11,12,12), //subcode 04.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,10,14,16,24,28,38,44,54,48,65,53,49,78,90,110,150,163,196,213,243,261,294,283,292,352,330,315,347,360,287,317,296,376,463,547,630,738,866,899,976,1007), //subcode 04.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,1,1,1,2,5,5,11,17,33,40,50,61,63,79,98,107,102,128,132,131,140,141,161,152,149,186,172,173,171,201,212,212,220,214,234,253,259,265,259) //subcode 04.20
                ), //end directorycode-array (04)
        new Array( //directory code 05
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,2,2,3,3,4,4,5,5,5,5,6,7,8,10,12,11,11,10,10,10,10,12,12,12,14,18,24,24,28,37,40,46,46,49,52,56,60,62), //subcode 05.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,2,3,3,2,2,2,2,5,5,6,6,7,8,8,8,9,10,10,10,10,12,12,12,12,14,15,15,15,19,18,19,20,20,22,25,26,29,29,28,31,30,33,33,33,35,32,26,26,29,29,29), //subcode 05.10
                new Array(0,0,0,0,0,0,0,1,1,5,8,10,15,25,32,38,43,47,49,52,55,56,34,55,76,89,112,115,134,139,151,159,151,152,174,186,190,209,222,235,267,278,279,297,307,324,340,346,367,360,371,384,409,445,453,468,469,493,510,532,610,629) //subcode 05.20
                ), //end directorycode-array (05)
        new Array( //directory code 06
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,3,3,3,3,3,5,6,7,8,9,10,11,11), //subcode 06.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,3,4,4,4,4,4,4,4,4,5,5,7,8,9,9,9,9,9,9,9,9,9,9,11,11,11,11,12,13,13,14,15,16,19,21,24,25,24,25,26,27,28,30,33,32,25,26,29,34,35), //subcode 06.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,3,11,15,15,20,29,33,36,37,38,43,48,57,58,75,89,91,98,101,109,108,115,126,133,140,145,155,163,170,178,189,195,199,196,204,218,190,181,181,184,190,204,208,213,205,217,223,230,224), //subcode 06.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,5,6,6,6,6,6,11,12,12,16,16,16,16,16,16,16,18,19,19,22,24,27,29,30,31,31,36,38,35,38,39,40,41,46,49,48,52,58,64,70,71) //subcode 06.30
                ), //end directorycode-array (06)
        new Array( //directory code 07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,3,3,4,4,3,0,0,0,0,2,3,3,4,5,6,6,8,8,9,10,9,9,11,9,11,11,13,15,15,16,15,16,16,16,16,18,19,19,21,21,20,23,23,23), //subcode 07.05
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,3,3,5,5,6,8,8,13,14,16,16,21,21,22,24,24), //subcode 07.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,4,6,6,3,3,3,3,3,4,5,5,6,6,10,14,30,32,33,34,34,35,35,34,40,39,41,41,43,44,46,46,47,48,52,53,52,53,54,55,57,58,58), //subcode 07.10
                new Array(0,0,0,0,0,1,2,3,6,7,8,14,18,18,20,24,26,30,40,48,52,57,67,83,99,107,125,133,170,178,187,189,205,211,212,221,220,225,231,245,253,270,278,280,285,301,309,310,312,312,328,344,355,367,379,390,401,412,420,438,462,461), //subcode 07.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,4,4,4,5,5,5,6,6,8,9,16,21,32,41,45,44,43,46,49,46,46,50,50,55,62,64,60,71,75,88,92,100,101,114,122,121,135,142,151,159,175,185,186), //subcode 07.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,4,4,6,7,7,7,10,15,20,18,22,34,38,46,49,51,52,61,69,74,79,81,91,103,106,144,172,218,253,278,290) //subcode 07.40
                ), //end directorycode-array (07)
        new Array( //directory code 08
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,5,7,7,8,8,8,9,9,10,10,13,14,14,16,16,15,16,16,16,16,13,12,12,14,14,14,14,15,15,16,16,17,20,18,16,17,19,22,22,23,24,30,35,37,41,43,43,44,44,46), //subcode 08.10
                new Array(0,0,0,0,0,0,4,7,11,11,4,4,4,5,11,14,15,16,26,36,39,49,70,72,80,95,103,115,133,144,160,156,166,180,188,211,214,231,251,260,269,281,293,297,314,316,316,314,304,314,313,318,314,320,324,327,333,338,334,332,328,327), //subcode 08.20
                new Array(0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,5,6,6,7,10,10,10,10,10,12,14,15,16,16,16,18,23,27,29,30,34,38,41,44,44,49,51,53,58,62,65,71,70,72,73,75,75,75,74,74), //subcode 08.30
                new Array(0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,3,4,5,5,4,4,5,8,16,18,20,23,25,27,30,31,31,31,32,30,31,31,32,41,98,156,211,297,393,515,633,850,1065,1331,1699,1982,2212,2460,2768,3064,3474,3789,4052,4323,4391), //subcode 08.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,4,4,4,7,7,6,7,9,11,14,23,22,24,26,26,28,23,23,24,20,20,19,19,19,19), //subcode 08.50
                new Array(0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,3,3,7,4,5,5,10,13,13,14,18,23,28,36,43,55,71,92,118,125,131,154,174,203,219,242,265,239,275,296,342,380,411,486,555,615,694,773,811,864,927,976,1041,1094,1128,1142), //subcode 08.60
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,2,2,2,4,4,5,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3), //subcode 08.70
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,3,3,3,4,5,5,6,7,12,10,11,8,10,11,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10), //subcode 08.80
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,2,2,3,3,5,5,5,2,12,12,12,12,16,15,15,14,14,14,14,14,14,15,15,14,14,18,20,20,20,20,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,19,19,19,19) //subcode 08.90
                ), //end directorycode-array (08)
        new Array( //directory code 09
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,3,3,3,6,6,6,7,8,8,8,8,9,9,10,10,11,11), //subcode 09.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,4,5,6,6,6,7,7,7,7,9,17,28,29,30,32,33,33,34), //subcode 09.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,3,7,8,9,12,14,18,18,18,22,27,30,33,37,39,48,52,56,60,63,68,77,79,82,89,117,107,110,112,131,144,137,149,164,183,183,204,213,182,192,197,185,205,206), //subcode 09.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,4,4,4,4,4,4,4,4,4,6,6,6,7,6,7,8,8,8,8,6,7,7,7,8,10,10,10,11,12,12,12), //subcode 09.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,3,3,3,3,3,3,3,3,3,3,3,3,5,5,5,7,8,9,9,10,16,17,18,18,19,24,24,25,26,27,28,29,30) //subcode 09.50
                ), //end directorycode-array (09)
        new Array( //directory code 10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,5,6,8,10,19,32,41,46,55,64,69,79,79,85,86,86,95,95), //subcode 10.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,4,4,4,4,5,4,2,2,2,2,2,1,1,1,1,1,2,3,5,5,5,5,5,5,5,5,5,5,6,7,7,7,7), //subcode 10.10
                new Array(0,0,0,0,0,0,0,0,1,1,1,1,2,2,5,5,5,5,6,6,6,11,12,16,20,22,24,26,34,34,38,39,42,42,40,41,42,42,38,38,38,35,35,35,35,34,34,35,40,50,55,69,77,84,90,95,90,100,110,123,129,134), //subcode 10.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,5,7,10,15,18,22,23,28,27,30,34,35,28,23,23,22,24,23,23,23,22,23,30,31,35,40,63,108,145,180,207,231,272,312,330,378,401,439,520,532), //subcode 10.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,3,3,3,3,3,3,3,3,3,3,3,3,3,4,5,6,8,9,5,6,6,7,6,7,9,11,14,15,14,18,20,24,35,48,49,50,52,57,58,59) //subcode 10.40
                ), //end directorycode-array (10)
        new Array( //directory code 11
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,3,5,1,0,0,0,0,0,0,0,0,2,4,4,4,4,5,6,7,9,9,10,10,9,11,11,8,10,10), //subcode 11.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,0,1,1,2,2,3,3,3,6,4,5,10,9,7,7,7,9,9,9,9,9,7,9,7,7,7,7,7,7), //subcode 11.20
                new Array(0,0,0,1,1,1,1,1,1,2,2,3,5,5,5,5,6,10,19,23,39,40,46,46,48,61,54,69,82,107,150,200,207,228,246,232,205,224,252,252,262,270,273,288,298,325,356,363,385,408,424,447,470,488,525,565,626,654,669,683,737,750), //subcode 11.30
                new Array(0,0,0,0,1,1,1,3,5,11,11,13,20,22,25,26,26,27,27,39,49,64,81,167,254,269,306,261,318,355,439,637,647,703,705,620,679,745,828,947,1004,985,1036,1015,969,1171,1370,1549,1755,1915,2140,2532,2868,3205,3447,3825,4135,4407,4765,4981,5232,5307), //subcode 11.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,3,6,6,6,4,8,6,6,6,6,9,11,21,17,16,35,37,30,37,56,55,47,32,14,14,19,21,35,81,97,105,119,120,126,134,157,181,204,225,244,257,265,267,262,268,261,262,264,270), //subcode 11.50
                new Array(0,0,0,0,0,0,0,0,0,1,2,5,10,11,12,14,14,21,23,26,38,43,52,60,75,78,98,118,154,158,190,242,263,315,370,337,324,358,385,398,406,440,459,483,475,502,495,524,588,618,721,730,762,853,893,899,945,959,993,1004,981,957), //subcode 11.60
                new Array(0,0,0,0,0,0,0,0,0,3,5,6,7,7,8,9,9,10,11,15,18,19,32,62,95,89,63,37,40,41,43,59,72,79,78,74,103,125,147,149,125,154,126,123,127,131,134,151,162,168,178,189,198,207,215,232,224,234,241,251,258,254) //subcode 11.70
                ), //end directorycode-array (11)
        new Array( //directory code 12
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,2,3,4,4,4,6,8,8,9,7), //subcode 12.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,3,4,5,6,14,21,23,26,30,34,35,39,40,49,48,51,52,52,50,52,53,54,57,59,58,61,60,68,76,78,79,71,70,71,72,71,73,75,93,99,100), //subcode 12.10
                new Array(0,0,0,2,3,3,7,11,14,13,6,6,6,7,10,11,11,14,17,15,15,15,17,22,22,23,26,32,36,40,45,48,54,58,63,65,57,63,70,77,83,95,100,60,66,68,73,75,79,84,85,92,99,98,98,97,97,97,97,97,97,97), //subcode 12.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,3,4,4,4,4,4,4,4,5,6,7,7,8,8,9,8,7,9,11,19,19,18,18,20,20,22,27,27,28,31,32,23), //subcode 12.30
                new Array(0,0,0,0,0,0,0,0,4,11,14,17,19,20,21,23,29,29,30,34,34,35,37,39,47,55,59,62,67,71,76,76,80,80,83,83,82,81,91,96,98,92,103,105,114,118,123,128,126,122,121,136,160,173,178,177,179,195,202,203,215,217), //subcode 12.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,4,7,8,12,14,16,17,28,28,28,28,30,30,29,29,29,29,28,30,25,25,25,27,29,22,19,22,18,20,20,20,20,17,18,18,18,18,22,22,21), //subcode 12.50
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,6,6,6,7,3,5,1,1,1,2,3,3,4,3,3,2,3,3,3,6,6,6,6,6,6,6,6,7,7,7,8,10,11) //subcode 12.60
                ), //end directorycode-array (12)
        new Array( //directory code 13
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,1,1,1,1,1,2,4,5,9,11,14,16,23,26,26,28,32,41,38,34,34,35,49,60,65,71,67,67,72,75,88,102,90,117,125,141,134,142,153,160,149,157,175,190,197,201), //subcode 13.10
                new Array(0,0,0,5,8,9,12,10,11,12,15,16,17,18,26,22,23,28,30,29,33,31,32,34,37,41,49,68,73,80,107,127,112,120,125,114,108,109,100,111,123,130,140,136,168,178,186,224,230,263,279,286,310,307,323,335,337,358,374,396,408,412), //subcode 13.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,7,13,14,17,30,44,57,64,76,106,128,167,192,226,251,276,299,332,355,377,393,425,458,496,543,579,600,633,686,710,713,784,882,908,923,982,1010,1055,1087,1164,1208,1269,1341,1414,1449,1595,1635), //subcode 13.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,1,4,4,5,6,8,9,12,14,18,21,22,28,30,40,37,39,42,50,56,66,70,74,81,98,106,107), //subcode 13.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,5,22,9,15,17,17,22,23,27,37,35,35,36,37,42,46,48,47,50) //subcode 13.60
                ), //end directorycode-array (13)
        new Array( //directory code 14
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,4,5,6,9,9,15,16,17,23,26,30,38,43,43,47,48,53,56,56,62,60,61,64,64), //subcode 14.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,6,6,10,8,8,10,9,9,9,12,11,12,15,15,16,16,19,19,16,19,19,24,23,22,24,22,23,23,24,25,25,24,23), //subcode 14.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,4,4,5,6,6,6,4,5,6,4,6,6,6,7,4,4,4,4,4,7,7,7,7,7,7,8,8,9,9,9,11,12,12), //subcode 14.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,4,3,6,8,6,8,8,9,9,9,9,9,9,9,9,9,10,10,13,12,13,13,13,13,11,11,11,11,11,11), //subcode 14.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,7,7,7,6,10,12,22,24,30,25,29,30,49,64,66,52,42,25,25,26,26,26,27,27,27,27,27,27,27,27,28,27,27,27,27,27), //subcode 14.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,9,4,34,51,156,111,101,23,216,233,248,332,338,233,249,256,382,390,399,405,271,287,304,334,344,355), //subcode 14.50
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,3,4,4,6,6,9,9,10,11,11,12,10,6,6,6,7,7) //subcode 14.60
                ), //end directorycode-array (14)
        new Array( //directory code 15
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,4,4,4,5,6,6,7,8,10,11,11,11,12,13,13,17,21,22,24,24,26,26,26), //subcode 15.07
                new Array(0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,4,4,4,4,5,5,7,13,15,30,40,50,64,80,92,107,125,141,168,180,198,222,252,279,289,309,323,389,396,401,429,465,502,542,579,659,671,726,769,810,848,876,944,958,988,1011), //subcode 15.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,1,0,0,0,4,5,5,8,15,12,12,19,19,20,26,33,40,49,58,70,80,94,117,131,139,153,178,206,238,264,303,346,399,450,489,528,587,635,697,841,882), //subcode 15.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,5,4,2,2,3,3,10,12,14,26,41,50,60,69,77,90,104,115,126,136,154,169,171,182,196,197,203,214,218,236,243,251), //subcode 15.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,2,3,3,3,6,6,9,10,11,13,14,14,15,14,14,16,22,24,24,24,24,28,28,28,29,31,30,32,34,34) //subcode 15.40
                ), //end directorycode-array (15)
        new Array( //directory code 16
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,4,6,5,5,5), //subcode 16.01
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,4,5,5,5,6,8,11,10,10,11,12,15,15), //subcode 16.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,6,6,7,9,18,21,23,20,27,28,30,37,30,38,35,41,61,73,64,62,59,58,60,64,46,64,67,69,61,67,70,75,78,81,86,88,93,96), //subcode 16.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,3,3,3,3,3,6,8,13,15,7,10,11,10,11,12,17,22,23,23,26,33,40,48,54,57,64,73,74,84,104,118,130,140,148,161,177,197,200), //subcode 16.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,3,3,4,4,5,6,6,6,8,11,14,17,19,23,22,23,32,31,32,42,47,50,55,59,86,108,121,131,129,137,132,137,147,140,149,162,174,185,185,190,170,156,164,164,172,174), //subcode 16.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,7,13,14,16,18,21,27,30,31,37,42,45,50,52,52,57,61,65,72,76,80,81,84,86,88,92,92) //subcode 16.40
                ), //end directorycode-array (16)
        new Array( //directory code 17
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,4,6,6,6,7,9,9,9,9,10,11,13,13,13,13,13,13,23,23,24,24,25,26,27,28,28,30,30,34,36,42,50,64,69,74,86,101,110,113), //subcode 17.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,5,5,5,5,5,5,5,5,6,7,7,9,10,17,19,21,22,28,33,40,42,43,47,49,52,54,58,65,71,76,79,83,90,87,90,91), //subcode 17.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,3,3,3,3,3,3,3,3,3,3,2,2,3,6,6,8,9,13,17,17,20,25,26,32,34,35,36) //subcode 17.30
                ), //end directorycode-array (17)
        new Array( //directory code 18
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,25,45,63,85,115,149,160,198,213,311,407,525,609,701,821,904,987,1027) //subcode 18.00
                ), //end directorycode-array (18)
        new Array( //directory code 19
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,3), //subcode 19.01
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,2,4,5,5,7,8,11,36,45,49,57,124,133,147,160,186,205,211,243,286,322,342,354), //subcode 19.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,4,4,4,5,5,6,7,7,7,8,8,13,18,19,21,26,31,34,38,44,49,59,64,80,83,84), //subcode 19.20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,7,8,23,44,64,76,114,151,175,193,219,245,255,276,299,323,353,374,378), //subcode 19.30
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,4,6,6,15,26,24,25,28,29,31,34,42,47,54,55), //subcode 19.40
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,6,6,6,6,9,12,12,14,14,20,28,32,33) //subcode 19.50
                ), //end directorycode-array (19)
        new Array( //directory code 20
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0), //subcode 20.07
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,4,4,4,4,6,6,6,7,7,8,8,8,8,8,10,10,10,10,12,13,10,10,10,11,11,11), //subcode 20.10
                new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,2,2,2,3,3,6,8,8,8,9,10,10,10,10,11,11,11,14,16,16,17,18) //subcode 20.20
                ) //end directorycode-array (20)
	); //end full array

subBubbleTitles = new Array(
	new Array('Statistics', 'Principles, objectives\nand tasks of the Treaties', 'General provisions', 'Scope of the Treaties', 'Provisions governing the institutions', 'Administration and Staff Regulations', 'Financial and budgetary provisions'), //dircode 1
	new Array('General', 'Statistics', 'General customs rules', 'Basic customs instruments', 'Application of the\nCommon Customs Tariff', 'Specific customs rules', 'Mutual assistance', 'Proceedings and penalties', 'International customs cooperation'), //dircode 2
	new Array('General', 'Statistics', 'Basic provisions', 'European Agricultural Guidance\nand Guarantee Fund (EAGGF)', 'Agricultural structures', 'Monetary measures', 'Approximation of laws\nand health measures', 'Products subject\nto market organisation', 'Products not subject\nto market organisation', 'Agreements with non-member countries'), //dircode 3
	new Array('General, supply and research','Statistics','Common fisheries policy','External relations'), //dircode 4
	new Array('Statistics', 'Freedom of movement for workers', 'Social policy'), //dircode 5
	new Array('Statistics','Principles and conditions','Sectoral application','Public contracts'), //dircode 6
	new Array('General', 'Statistics', 'Transport infrastructure', 'Inland transport', 'Shipping', 'Air transport'), //dircode 7
	new Array('Competition principles', 'Restrictive practices', 'Dominant positions', 'Concentrations', 'Application of the rules of\ncompetition to public undertakings', 'State aids and other subsidies', 'Intra-Community dumping practices', 'Obligations of undertakings', 'National trading monopolies'), //dircode 8
	new Array('General','Direct taxation','Indirect taxation','Other taxes','Prevention of tax evasion\nand avoidance'), //dircode 9
	new Array('Statistics','General','Monetary policy','Economic policy','Free movement of capital'), //dircode 10
	new Array('General', 'European political cooperation', 'Multilateral relations', 'Bilateral agreements\nwith non-member countries', 'Action in favour of\ncountries in transition', 'Commercial policy', 'Development policy'), //dircode 11
	new Array('Statistics','General principles and programmes','Coal','Electricity','Nuclear energy','Oil and gas','Other sources of energy'), //dircode 12
	new Array('Industrial policy: general,\nprogrammes, statistics and research', 'Industrial policy:\nsectoral operations', 'Internal market:\napproximation of laws', 'Internal market: policy\nrelating to undertakings', 'Trans-European networks'), //dircode 13
	new Array('Statistics','General principles,\nprogrammes and statistics','European Regional\nDevelopment Fund (ERDF)','Monitoring and coordination\nof regional State aids','Autonomous regional action','Coordination of structural instruments','Economic and social\ncohesion fund'), //dircode 14
	new Array('Statistics','Environment','Consumers','Health protection','Protection of animals'), //dircode 15
	new Array('General','Statistics','Science','Dissemination of information','Education and training','Culture'), //dircode 16
	new Array('Company law','Intellectual property law','Economic and commercial law'), //dircode 17
	new	Array('Common Foreign and Security Policy'), //dircode 18
	new Array('General','Free movement of persons','Judicial cooperation in civil matters','Police and judicial cooperation\nin criminal and customs matters','Programmes','External relations'), //dircode 19
	new Array('General','Statistics','Freedom of movement of people','European citizenship') //dircode 20
); //end subBubbleTitles

var subBubblePosX:Array = new Array(
	new Array(300, 200, 300, 250, 500, 640, 460), //1=7
	new Array(300, 200, 300, 250, 500, 665, 460, 600, 430), //2 = 9 subbubbles
	new Array(300, 200, 300, 250, 410, 400, 460, 600, 660, 675), //3=10
	new Array(300, 460, 500, 250), //4=4
	new Array(580, 460, 320), //5=3
	new Array(300, 445, 500, 250), //6=4
	new Array(620, 590, 280, 235, 500, 460), //7=6
	new Array(300, 200, 300, 500, 665, 270, 460, 600, 430), //8=9
	new Array(580, 590, 370, 235, 500), //9=5
	new Array(580, 590, 430, 260, 500), //10=5
	new Array(350, 200, 300, 500, 300, 640, 460), //11=7
	new Array(550, 200, 330, 300, 500, 640, 490), //12=7
	new Array(600, 620, 400, 260, 490), //13=5
	new Array(300, 200, 300, 250, 640, 500, 460), //14=7
	new Array(380, 590, 390, 260, 590), //15=5
	new Array(280, 200, 620, 235, 500, 425), //16=6
	new Array(580, 460, 320), //17=3
	new Array(450,0), //18=1
	new Array(440, 620, 500, 235, 290, 425), //19=6
	new Array(460, 580, 320) //20=3
); //end subBubblePosX

var subBubblePosY:Array = new Array(
	new Array(100, 200, 300, 400, 150, 330, 385), //1=7
	new Array(100, 180, 270, 400, 150, 300, 385, 400, 320), //2 = 9 subbubbles
	new Array(100, 180, 270, 400, 200, 100, 385, 140, 285, 370), //3=10
	new Array(200, 330, 150, 300), //4=4
	new Array(280, 180, 320), //5=3
	new Array(180, 355, 150, 300), //6=4
	new Array(330, 255, 400, 200, 150, 385), //7=6
	new Array(100, 180, 270, 150, 300, 380, 385, 400, 320), //8=9
	new Array(355, 255, 330, 200, 150), //9=5
	new Array(355, 255, 320, 200, 150), //10=5
	new Array(400, 200, 300, 150, 100, 330, 385), //11=7
	new Array(400, 200, 350, 80, 150, 320, 335), //12=7
	new Array(345, 175, 290, 160, 130), //13=5
	new Array(100, 200, 300, 400, 330, 150, 385), //14=7
	new Array(155, 185, 370, 200, 380), //15=5
	new Array(400, 430, 360, 200, 150, 385), //16=6
	new Array(370, 135, 320), //17=3
	new Array(250,0), //18=1
	new Array(300, 360, 150, 200, 430, 385), //19=6
	new Array(180, 280, 320) //20=3
); //end subBubblePosY



//////////////////DATA END//////////////////
			const timeunit:Number = 0.7; //in seconds

			thisyear = 0; //current year from 1950
			circles = new Array;
			subCircles = [];
			
			var tmp:Array = getCirclePositions(circleRadius);
			var circleCenterX:Array = tmp[0];
			var circleCenterY:Array = tmp[1];

			var fontLoader:Loader = new Loader();
			var fontLoaderInfo:LoaderInfo = fontLoader.contentLoaderInfo;
			fontLoaderInfo.addEventListener(Event.COMPLETE, onFontLoaded);
			fontLoader.load(new URLRequest("arial.swf"));
//			fontLoader.load(new URLRequest("http://www.itsyourparliament.eu/ctemp/arial.swf"));

			function onFontLoaded (e:Event):void {
				scenary = new Scenary(timeunit); //set scenary
				addChild(scenary);
				setChildIndex(scenary, 0);
				setActInfo();
				for (var ci:int = 0; ci < circleNames.length; ci++ ) {
					circles[ci] = new Bubble(circleCenterX[ci], circleCenterY[ci], circleRadius[ci], circleNames[ci], numberOfActs[ci], numberOfDirectives[ci], numberOfRegulations[ci], numberOfDecisions[ci], circleSubRadius[ci], timeunit, 0xFFFFFF, true, subBubbleTitles[ci], subNumberOfDirectives[ci], subNumberOfRegulations[ci], subNumberOfDecisions[ci], getColor(), subBubblePosX[ci], subBubblePosY[ci], getSubColors(ci)); //create bubble objects
					addChild(circles[ci]);
				}
				changeYear(0); //start animation
			} //end onFontLoaded

		} //end init

		public function changeYear(newyear:int):void {
			if (newyear > maxYear) return;
			thisyear = newyear;
			if (subCircles.length < 1) {
				for (var ci:int = 0; ci < numberOfCircles; ci++ ) {
					circles[ci].resizeBubble(thisyear); //resize circles
				}
			}
			else { //subScene
				for (var ij:int = 0; ij < subCircles.length; ij++ ) {
					subCircles[ij].resizeBubble(thisyear); //resize circles
				}
			}
			scenary.moveTimeline(thisyear); //movetimeline
			scenary.updateActInfo();
		/*	if (thisyear == maxYear) {
				scenary.addReplay();
			}
			else {
				scenary.removeReplay();
			}*/
		} //end changeYear

		public function nextYear():void {
			if (runAnimation)
				changeYear(thisyear + 1);
		} //end nextYear
		
		public function getSubColors(bubbleNr:int):Array {
			var subColors:Array = new Array();
			for (var i:int = 0; i < subBubbleTitles[bubbleNr].length; i++) {
				subColors[i] = getColor();
			}
			clrNr -= subBubbleTitles[bubbleNr].length;
			return subColors;
		}
		
		public function getColor():Array {
			var colors:Array = new Array(
										new Array(37,204,222),
										new Array(41,148,156),
										new Array(43,123,210),
										new Array(166,60,70),
										new Array(33,95,32),
										new Array(64,98,159),
										new Array(26,116,78),
										new Array(118,217,46),
										new Array(110,243,198),
										new Array(237,195,245), //10
										new Array(180,160,199),
										new Array(222, 183, 129),
										new Array(209,99,126),
										new Array(127, 230, 177),
										new Array(123, 43, 210),
										new Array(220, 220, 38),
										new Array(148, 156, 41),
										new Array(41, 148, 41),
										new Array(168, 61, 176),
										new Array(123, 210, 43)
								);
			var red:int = colors[clrNr%colors.length][0];
			var green:int = colors[clrNr%colors.length][1];
			var blue:int = colors[clrNr%colors.length][2];
 			var bubbleColor:int = int("0x" + red.toString(16) + green.toString(16) + blue.toString(16));
			red = Math.min(255, red + 50);
			green = Math.min(255, green + 50);
			blue = Math.min(255, blue + 50);
  			var bubbleColorLight:int = int("0x" + red.toString(16) + green.toString(16) + blue.toString(16));
			clrNr++;
			return [bubbleColor, bubbleColorLight];
		}
		
		public function getCirclePositions(circleRadius:Array):Array {
			var circleCenterX:Array = new Array(719, 80, 200, 575, 210, 430, 525, 380, 360, 205,
												680, 505, 575, 655, 425, 340, 545, 320, 715, 135);
			var circleCenterY:Array = new Array(210, 85, 270, 240, 430, 75, 440, 410, 267, 90, 
												385, 305, 70, 137, 190, 40, 160, 130, 80, 145);
/*
			//place circles
			for (var j:int = 0; j < circleRadius.length; j++) {
//				circleCenterX[j] = Math.floor(Math.random() * (1 + 780 - circleRadius[j][maxYear] - circleRadius[j][maxYear])) + circleRadius[j][maxYear];
				circleCenterY[j] = Math.floor(Math.random() * (1 + 515 - circleRadius[j][maxYear] - circleRadius[j][maxYear]-5)) + circleRadius[j][maxYear]+5;
				//check for overlap
				var it:int = 0;
				while (overlap(j,circleCenterX,circleCenterY,circleRadius)) {
					if (it++ > 10000) break;
//					circleCenterX[j] = Math.floor(Math.random() * (1 + 780 - circleRadius[j][maxYear] - circleRadius[j][maxYear])) + circleRadius[j][maxYear];
					circleCenterY[j] = Math.floor(Math.random() * (1 + 515 - circleRadius[j][maxYear] - circleRadius[j][maxYear]-5)) + circleRadius[j][maxYear]+5;
				}
			}
*/
			return [circleCenterX, circleCenterY];
		} //end getCirclePositions
		
		public function overlap(circleNr:int,circleCenterX:Array,circleCenterY:Array,circleRadius:Array):Boolean {
			if (circleNr < 1) return false;
			for (var jij:int = circleNr-1; jij >= 0; jij--) {
				var a:int = circleCenterX[circleNr]-circleCenterX[jij];
				var b:int = circleCenterY[circleNr]-circleCenterY[jij];
				var r:int = (circleRadius[circleNr][maxYear] + circleRadius[jij][maxYear])*1.1;
				if (a * a + b * b < r * r) return true;
			}
			return false;
		} //end overlap

		public function setSubCircles(sCircles:Array):void {
			subCircles = sCircles;
		}

		public function setActInfo():void {
			scenary.setInfoBoxText("EU legislation", "Each circle represents a specific area of European Union activity. The area of the circle reflects the number of EU legislative acts in force within the policy area.\n\nUse the timeline to navigate in time. Place the cursor on a circle to see details or click on it to view additional information.");
			scenary.setActInfo(totalNumberOfActs, totalNumberOfDirectives, totalNumberOfRegulations, totalNumberOfDecisions);
		}
		
		} //end main class
} //end package